 ;==========================================================================;
;*  Copyright (C) Microsoft Corporation.  All Rights Reserved.
;*  File:       d3d9caps.h
;*  Content:    Direct3D capabilities include file
;***************************************************************************/
IFNDEF _d3d9CAPS_H
IFNDEF DIRECT3D_VERSION
DIRECT3D_VERSION	equ	<00900h>
ENDIF  ;DIRECT3D_VERSION
 ; include this file content only if compiling for DX9 interfaces
IF (COMPARE (DIRECT3D_VERSION,GE,00900h))
IF DEFINED (_X86_) OR DEFINED (_IA64) 
;ECHO   pack(4)
ENDIF 

D3DVSHADERCAPS2_0	STRUCT
	Caps DWORD ?
	DynamicFlowControlDepth DWORD ?
	NumTemps DWORD ?
	StaticFlowControlDepth DWORD ?

D3DVSHADERCAPS2_0		ENDS

D3DVS20_MAX_DYNAMICFLOWCONTROLDEPTH	equ	<24>
D3DVS20_MIN_DYNAMICFLOWCONTROLDEPTH	equ	<0>
D3DVS20_MAX_NUMTEMPS	equ	<32>
D3DVS20_MIN_NUMTEMPS	equ	<12>
D3DVS20_MAX_STATICFLOWCONTROLDEPTH	equ	<4>
D3DVS20_MIN_STATICFLOWCONTROLDEPTH	equ	<1>

D3DPSHADERCAPS2_0	STRUCT
	Caps DWORD ?
	DynamicFlowControlDepth DWORD ?
	NumTemps DWORD ?
	StaticFlowControlDepth DWORD ?
	NumInstructionSlots DWORD ?

D3DPSHADERCAPS2_0		ENDS

D3DPS20_MAX_DYNAMICFLOWCONTROLDEPTH	equ	<24>
D3DPS20_MIN_DYNAMICFLOWCONTROLDEPTH	equ	<0>
D3DPS20_MAX_NUMTEMPS	equ	<32>
D3DPS20_MIN_NUMTEMPS	equ	<12>
D3DPS20_MAX_STATICFLOWCONTROLDEPTH	equ	<4>
D3DPS20_MIN_STATICFLOWCONTROLDEPTH	equ	<0>
D3DPS20_MAX_NUMINSTRUCTIONSLOTS	equ	<512>
D3DPS20_MIN_NUMINSTRUCTIONSLOTS	equ	<96>
D3DMIN30SHADERINSTRUCTIONS	equ	<512>
D3DMAX30SHADERINSTRUCTIONS	equ	<32768>

D3DCAPS9	STRUCT
	DeviceType  DWORD ?
	AdapterOrdinal DWORD ?
	Caps DWORD ?
	Caps2 DWORD ?
	Caps3 DWORD ?
	PresentationIntervals DWORD ?
	CursorCaps DWORD ?
	DevCaps DWORD ?
	PrimitiveMiscCaps DWORD ?
	RasterCaps DWORD ?
	ZCmpCaps DWORD ?
	SrcBlendCaps DWORD ?
	DestBlendCaps DWORD ?
	AlphaCmpCaps DWORD ?
	ShadeCaps DWORD ?
	TextureCaps DWORD ?
	TextureFilterCaps DWORD ?  ; D3DPTFILTERCAPS for IDirect3DTexture9's
	CubeTextureFilterCaps DWORD ?  ; D3DPTFILTERCAPS for IDirect3DCubeTexture9's
	VolumeTextureFilterCaps DWORD ?  ; D3DPTFILTERCAPS for IDirect3DVolumeTexture9's
	TextureAddressCaps DWORD ?  ; D3DPTADDRESSCAPS for IDirect3DTexture9's
	VolumeTextureAddressCaps DWORD ?  ; D3DPTADDRESSCAPS for IDirect3DVolumeTexture9's
	LineCaps DWORD ?  ; D3DLINECAPS
	MaxTextureWidth DWORD ?
	MaxVolumeExtent DWORD ?
	MaxTextureRepeat DWORD ?
	MaxTextureAspectRatio DWORD ?
	MaxAnisotropy DWORD ?
	MaxVertexW DWORD ?
	GuardBandLeft DWORD ?
	GuardBandTop DWORD ?
	GuardBandRight DWORD ?
	GuardBandBottom DWORD ?
	ExtentsAdjust DWORD ?
	StencilCaps DWORD ?
	FVFCaps DWORD ?
	TextureOpCaps DWORD ?
	MaxTextureBlendStages DWORD ?
	MaxSimultaneousTextures DWORD ?
	VertexProcessingCaps DWORD ?
	MaxActiveLights DWORD ?
	MaxUserClipPlanes DWORD ?
	MaxVertexBlendMatrices DWORD ?
	MaxVertexBlendMatrixIndex DWORD ?
	MaxPointSize DWORD ?
	MaxPrimitiveCount DWORD ?  ; max number of primitives per DrawPrimitive call
	MaxVertexIndex DWORD ?
	MaxStreams DWORD ?
	MaxStreamStride DWORD ?  ; max stride for SetStreamSource
	VertexShaderVersion DWORD ?
	MaxVertexShaderConst DWORD ?  ; number of vertex shader constant registers
	PixelShaderVersion DWORD ?
	PixelShader1xMaxValue DWORD ?  ; max value storable in registers of ps.1.x shaders
	DevCaps2 DWORD ?
	MaxNpatchTessellationLevel DWORD ?
	Reserved5 DWORD ?
	MasterAdapterOrdinal DWORD ?  ; ordinal of master adaptor for adapter group
	AdapterOrdinalInGroup DWORD ?  ; ordinal inside the adapter group
	NumberOfAdaptersInGroup DWORD ?  ; number of adapters in this adapter group (only if master)
	DeclTypes DWORD ?  ; Data types, supported in vertex declarations
	NumSimultaneousRTs DWORD ?  ; Will be at least 1
	StretchRectFilterCaps DWORD ?  ; Filter caps supported by StretchRect
	VS20Caps D3DVSHADERCAPS2_0 <> 
	PS20Caps D3DPSHADERCAPS2_0 <> 
	VertexTextureFilterCaps DWORD ?  ; D3DPTFILTERCAPS for IDirect3DTexture9's for texture, used in vertex shaders
	MaxVShaderInstructionsExecuted DWORD ?  ; maximum number of vertex shader instructions that can be executed
	MaxPShaderInstructionsExecuted DWORD ?  ; maximum number of pixel shader instructions that can be executed
	MaxVertexShader30InstructionSlots DWORD ?
	MaxPixelShader30InstructionSlots DWORD ?

D3DCAPS9		ENDS

 ;
 ; BIT DEFINES FOR D3DCAPS9 DWORD MEMBERS
 ;
 ;
 ; Caps
 ;
D3DCAPS_READ_SCANLINE	equ	<000020000h>
 ;
 ; Caps2
 ;
D3DCAPS2_FULLSCREENGAMMA	equ	<000020000h>
D3DCAPS2_CANCALIBRATEGAMMA	equ	<000100000h>
D3DCAPS2_RESERVED	equ	<002000000h>
D3DCAPS2_CANMANAGERESOURCE	equ	<010000000h>
D3DCAPS2_DYNAMICTEXTURES	equ	<020000000h>
D3DCAPS2_CANAUTOGENMIPMAP	equ	<040000000h>
 ;
 ; Caps3
 ;
D3DCAPS3_RESERVED	equ	<08000001fh>
 ; Indicates that the device can respect the ALPHABLENDENABLE render state
 ; when fullscreen while using the FLIP or DISCARD swap effect.
 ; COPY and COPYVSYNC swap effects work whether or not this flag is set.
D3DCAPS3_ALPHA_FULLSCREEN_FLIP_OR_DISCARD	equ	<000000020h>
 ; Indicates that the device can perform a gamma correction from
 ; a windowed back buffer containing linear content to the sRGB desktop.
D3DCAPS3_LINEAR_TO_SRGB_PRESENTATION	equ	<000000080h>
D3DCAPS3_COPY_TO_VIDMEM	equ	<000000100h>
D3DCAPS3_COPY_TO_SYSTEMMEM	equ	<000000200h>
 ;
 ; PresentationIntervals
 ;
D3DPRESENT_INTERVAL_DEFAULT	equ	<000000000h>
D3DPRESENT_INTERVAL_ONE	equ	<000000001h>
D3DPRESENT_INTERVAL_TWO	equ	<000000002h>
D3DPRESENT_INTERVAL_THREE	equ	<000000004h>
D3DPRESENT_INTERVAL_FOUR	equ	<000000008h>
D3DPRESENT_INTERVAL_IMMEDIATE	equ	<080000000h>
 ;
 ; CursorCaps
 ;
 ; Driver supports HW color cursor in at least hi-res modes(height >=400)
D3DCURSORCAPS_COLOR	equ	<000000001h>
 ; Driver supports HW cursor also in low-res modes(height < 400)
D3DCURSORCAPS_LOWRES	equ	<000000002h>
 ;
 ; DevCaps
 ;
D3DDEVCAPS_EXECUTESYSTEMMEMORY	equ	<000000010h>
D3DDEVCAPS_EXECUTEVIDEOMEMORY	equ	<000000020h>
D3DDEVCAPS_TLVERTEXSYSTEMMEMORY	equ	<000000040h>
D3DDEVCAPS_TLVERTEXVIDEOMEMORY	equ	<000000080h>
D3DDEVCAPS_TEXTURESYSTEMMEMORY	equ	<000000100h>
D3DDEVCAPS_TEXTUREVIDEOMEMORY	equ	<000000200h>
D3DDEVCAPS_DRAWPRIMTLVERTEX	equ	<000000400h>
D3DDEVCAPS_CANRENDERAFTERFLIP	equ	<000000800h>
D3DDEVCAPS_TEXTURENONLOCALVIDMEM	equ	<000001000h>
D3DDEVCAPS_DRAWPRIMITIVES2	equ	<000002000h>
D3DDEVCAPS_SEPARATETEXTUREMEMORIES	equ	<000004000h>
D3DDEVCAPS_DRAWPRIMITIVES2EX	equ	<000008000h>
D3DDEVCAPS_HWTRANSFORMANDLIGHT	equ	<000010000h>
D3DDEVCAPS_CANBLTSYSTONONLOCAL	equ	<000020000h>
D3DDEVCAPS_HWRASTERIZATION	equ	<000080000h>
D3DDEVCAPS_PUREDEVICE	equ	<000100000h>
D3DDEVCAPS_QUINTICRTPATCHES	equ	<000200000h>
D3DDEVCAPS_RTPATCHES	equ	<000400000h>
D3DDEVCAPS_RTPATCHHANDLEZERO	equ	<000800000h>
D3DDEVCAPS_NPATCHES	equ	<001000000h>
 ;
 ; PrimitiveMiscCaps
 ;
D3DPMISCCAPS_MASKZ	equ	<000000002h>
D3DPMISCCAPS_CULLNONE	equ	<000000010h>
D3DPMISCCAPS_CULLCW	equ	<000000020h>
D3DPMISCCAPS_CULLCCW	equ	<000000040h>
D3DPMISCCAPS_COLORWRITEENABLE	equ	<000000080h>
D3DPMISCCAPS_CLIPPLANESCALEDPOINTS	equ	<000000100h>
D3DPMISCCAPS_CLIPTLVERTS	equ	<000000200h>
D3DPMISCCAPS_TSSARGTEMP	equ	<000000400h>
D3DPMISCCAPS_BLENDOP	equ	<000000800h>
D3DPMISCCAPS_NULLREFERENCE	equ	<000001000h>
D3DPMISCCAPS_INDEPENDENTWRITEMASKS	equ	<000004000h>
D3DPMISCCAPS_PERSTAGECONSTANT	equ	<000008000h>
D3DPMISCCAPS_SEPARATEALPHABLEND	equ	<000020000h>
D3DPMISCCAPS_MRTINDEPENDENTBITDEPTHS	equ	<000040000h>
D3DPMISCCAPS_MRTPOSTPIXELSHADERBLENDING	equ	<000080000h>
D3DPMISCCAPS_FOGVERTEXCLAMPED	equ	<000100000h>
 ;
 ; LineCaps
 ;
D3DLINECAPS_TEXTURE	equ	<000000001h>
D3DLINECAPS_ZTEST	equ	<000000002h>
D3DLINECAPS_BLEND	equ	<000000004h>
D3DLINECAPS_ALPHACMP	equ	<000000008h>
D3DLINECAPS_FOG	equ	<000000010h>
D3DLINECAPS_ANTIALIAS	equ	<000000020h>
 ;
 ; RasterCaps
 ;
D3DPRASTERCAPS_DITHER	equ	<000000001h>
D3DPRASTERCAPS_ZTEST	equ	<000000010h>
D3DPRASTERCAPS_FOGVERTEX	equ	<000000080h>
D3DPRASTERCAPS_FOGTABLE	equ	<000000100h>
D3DPRASTERCAPS_MIPMAPLODBIAS	equ	<000002000h>
D3DPRASTERCAPS_ZBUFFERLESSHSR	equ	<000008000h>
D3DPRASTERCAPS_FOGRANGE	equ	<000010000h>
D3DPRASTERCAPS_ANISOTROPY	equ	<000020000h>
D3DPRASTERCAPS_WBUFFER	equ	<000040000h>
D3DPRASTERCAPS_WFOG	equ	<000100000h>
D3DPRASTERCAPS_ZFOG	equ	<000200000h>
D3DPRASTERCAPS_COLORPERSPECTIVE	equ	<000400000h>
D3DPRASTERCAPS_SCISSORTEST	equ	<001000000h>
D3DPRASTERCAPS_SLOPESCALEDEPTHBIAS	equ	<002000000h>
D3DPRASTERCAPS_DEPTHBIAS	equ	<004000000h>
D3DPRASTERCAPS_MULTISAMPLE_TOGGLE	equ	<008000000h>
 ;
 ; ZCmpCaps, AlphaCmpCaps
 ;
D3DPCMPCAPS_NEVER	equ	<000000001h>
D3DPCMPCAPS_LESS	equ	<000000002h>
D3DPCMPCAPS_EQUAL	equ	<000000004h>
D3DPCMPCAPS_LESSEQUAL	equ	<000000008h>
D3DPCMPCAPS_GREATER	equ	<000000010h>
D3DPCMPCAPS_NOTEQUAL	equ	<000000020h>
D3DPCMPCAPS_GREATEREQUAL	equ	<000000040h>
D3DPCMPCAPS_ALWAYS	equ	<000000080h>
 ;
 ; SourceBlendCaps, DestBlendCaps
 ;
D3DPBLENDCAPS_ZERO	equ	<000000001h>
D3DPBLENDCAPS_ONE	equ	<000000002h>
D3DPBLENDCAPS_SRCCOLOR	equ	<000000004h>
D3DPBLENDCAPS_INVSRCCOLOR	equ	<000000008h>
D3DPBLENDCAPS_SRCALPHA	equ	<000000010h>
D3DPBLENDCAPS_INVSRCALPHA	equ	<000000020h>
D3DPBLENDCAPS_DESTALPHA	equ	<000000040h>
D3DPBLENDCAPS_INVDESTALPHA	equ	<000000080h>
D3DPBLENDCAPS_DESTCOLOR	equ	<000000100h>
D3DPBLENDCAPS_INVDESTCOLOR	equ	<000000200h>
D3DPBLENDCAPS_SRCALPHASAT	equ	<000000400h>
D3DPBLENDCAPS_BOTHSRCALPHA	equ	<000000800h>
D3DPBLENDCAPS_BOTHINVSRCALPHA	equ	<000001000h>
D3DPBLENDCAPS_BLENDFACTOR	equ	<000002000h>
 ;
 ; ShadeCaps
 ;
D3DPSHADECAPS_COLORGOURAUDRGB	equ	<000000008h>
D3DPSHADECAPS_SPECULARGOURAUDRGB	equ	<000000200h>
D3DPSHADECAPS_ALPHAGOURAUDBLEND	equ	<000004000h>
D3DPSHADECAPS_FOGGOURAUD	equ	<000080000h>
 ;
 ; TextureCaps
 ;
D3DPTEXTURECAPS_PERSPECTIVE	equ	<000000001h>
D3DPTEXTURECAPS_POW2	equ	<000000002h>
D3DPTEXTURECAPS_ALPHA	equ	<000000004h>
D3DPTEXTURECAPS_SQUAREONLY	equ	<000000020h>
D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE	equ	<000000040h>
D3DPTEXTURECAPS_ALPHAPALETTE	equ	<000000080h>
 ; Device can use non-POW2 textures if:
 ;  1) D3DTEXTURE_ADDRESS is set to CLAMP for this texture's stage
 ;  2) D3DRS_WRAP(N) is zero for this texture's coordinates
 ;  3) mip mapping is not enabled (use magnification filter only)
D3DPTEXTURECAPS_NONPOW2CONDITIONAL	equ	<000000100h>
D3DPTEXTURECAPS_PROJECTED	equ	<000000400h>
D3DPTEXTURECAPS_CUBEMAP	equ	<000000800h>
D3DPTEXTURECAPS_VOLUMEMAP	equ	<000002000h>
D3DPTEXTURECAPS_MIPMAP	equ	<000004000h>
D3DPTEXTURECAPS_MIPVOLUMEMAP	equ	<000008000h>
D3DPTEXTURECAPS_MIPCUBEMAP	equ	<000010000h>
D3DPTEXTURECAPS_CUBEMAP_POW2	equ	<000020000h>
D3DPTEXTURECAPS_VOLUMEMAP_POW2	equ	<000040000h>
 ;
 ; TextureFilterCaps, StretchRectFilterCaps
 ;
D3DPTFILTERCAPS_MINFPOINT	equ	<000000100h>
D3DPTFILTERCAPS_MINFLINEAR	equ	<000000200h>
D3DPTFILTERCAPS_MINFANISOTROPIC	equ	<000000400h>
D3DPTFILTERCAPS_MINFPYRAMIDALQUAD	equ	<000000800h>
D3DPTFILTERCAPS_MINFGAUSSIANQUAD	equ	<000001000h>
D3DPTFILTERCAPS_MIPFPOINT	equ	<000010000h>
D3DPTFILTERCAPS_MIPFLINEAR	equ	<000020000h>
D3DPTFILTERCAPS_MAGFPOINT	equ	<001000000h>
D3DPTFILTERCAPS_MAGFLINEAR	equ	<002000000h>
D3DPTFILTERCAPS_MAGFANISOTROPIC	equ	<004000000h>
D3DPTFILTERCAPS_MAGFPYRAMIDALQUAD	equ	<008000000h>
D3DPTFILTERCAPS_MAGFGAUSSIANQUAD	equ	<010000000h>
 ;
 ; TextureAddressCaps
 ;
D3DPTADDRESSCAPS_WRAP	equ	<000000001h>
D3DPTADDRESSCAPS_MIRROR	equ	<000000002h>
D3DPTADDRESSCAPS_CLAMP	equ	<000000004h>
D3DPTADDRESSCAPS_BORDER	equ	<000000008h>
D3DPTADDRESSCAPS_INDEPENDENTUV	equ	<000000010h>
D3DPTADDRESSCAPS_MIRRORONCE	equ	<000000020h>
 ;
 ; StencilCaps
 ;
D3DSTENCILCAPS_KEEP	equ	<000000001h>
D3DSTENCILCAPS_ZERO	equ	<000000002h>
D3DSTENCILCAPS_REPLACE	equ	<000000004h>
D3DSTENCILCAPS_INCRSAT	equ	<000000008h>
D3DSTENCILCAPS_DECRSAT	equ	<000000010h>
D3DSTENCILCAPS_INVERT	equ	<000000020h>
D3DSTENCILCAPS_INCR	equ	<000000040h>
D3DSTENCILCAPS_DECR	equ	<000000080h>
D3DSTENCILCAPS_TWOSIDED	equ	<000000100h>
 ;
 ; TextureOpCaps
 ;
D3DTEXOPCAPS_DISABLE	equ	<000000001h>
D3DTEXOPCAPS_SELECTARG1	equ	<000000002h>
D3DTEXOPCAPS_SELECTARG2	equ	<000000004h>
D3DTEXOPCAPS_MODULATE	equ	<000000008h>
D3DTEXOPCAPS_MODULATE2X	equ	<000000010h>
D3DTEXOPCAPS_MODULATE4X	equ	<000000020h>
D3DTEXOPCAPS_ADD	equ	<000000040h>
D3DTEXOPCAPS_ADDSIGNED	equ	<000000080h>
D3DTEXOPCAPS_ADDSIGNED2X	equ	<000000100h>
D3DTEXOPCAPS_SUBTRACT	equ	<000000200h>
D3DTEXOPCAPS_ADDSMOOTH	equ	<000000400h>
D3DTEXOPCAPS_BLENDDIFFUSEALPHA	equ	<000000800h>
D3DTEXOPCAPS_BLENDTEXTUREALPHA	equ	<000001000h>
D3DTEXOPCAPS_BLENDFACTORALPHA	equ	<000002000h>
D3DTEXOPCAPS_BLENDTEXTUREALPHAPM	equ	<000004000h>
D3DTEXOPCAPS_BLENDCURRENTALPHA	equ	<000008000h>
D3DTEXOPCAPS_PREMODULATE	equ	<000010000h>
D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR	equ	<000020000h>
D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA	equ	<000040000h>
D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR	equ	<000080000h>
D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA	equ	<000100000h>
D3DTEXOPCAPS_BUMPENVMAP	equ	<000200000h>
D3DTEXOPCAPS_BUMPENVMAPLUMINANCE	equ	<000400000h>
D3DTEXOPCAPS_DOTPRODUCT3	equ	<000800000h>
D3DTEXOPCAPS_MULTIPLYADD	equ	<001000000h>
D3DTEXOPCAPS_LERP	equ	<002000000h>
 ;
 ; FVFCaps
 ;
D3DFVFCAPS_TEXCOORDCOUNTMASK	equ	<00000ffffh>
D3DFVFCAPS_DONOTSTRIPELEMENTS	equ	<000080000h>
D3DFVFCAPS_PSIZE	equ	<000100000h>
 ;
 ; VertexProcessingCaps
 ;
D3DVTXPCAPS_TEXGEN	equ	<000000001h>
D3DVTXPCAPS_MATERIALSOURCE7	equ	<000000002h>
D3DVTXPCAPS_DIRECTIONALLIGHTS	equ	<000000008h>
D3DVTXPCAPS_POSITIONALLIGHTS	equ	<000000010h>
D3DVTXPCAPS_LOCALVIEWER	equ	<000000020h>
D3DVTXPCAPS_TWEENING	equ	<000000040h>
D3DVTXPCAPS_TEXGEN_SPHEREMAP	equ	<000000100h>
 ;
 ; DevCaps2
 ;
D3DDEVCAPS2_STREAMOFFSET	equ	<000000001h>
D3DDEVCAPS2_DMAPNPATCH	equ	<000000002h>
D3DDEVCAPS2_ADAPTIVETESSRTPATCH	equ	<000000004h>
D3DDEVCAPS2_ADAPTIVETESSNPATCH	equ	<000000008h>
D3DDEVCAPS2_CAN_STRETCHRECT_FROM_TEXTURES	equ	<000000010h>
D3DDEVCAPS2_PRESAMPLEDDMAPNPATCH	equ	<000000020h>
D3DDEVCAPS2_VERTEXELEMENTSCANSHARESTREAMOFFSET	equ	<000000040h>
 ;
 ; DeclTypes
 ;
D3DDTCAPS_UBYTE4	equ	<000000001h>
D3DDTCAPS_UBYTE4N	equ	<000000002h>
D3DDTCAPS_SHORT2N	equ	<000000004h>
D3DDTCAPS_SHORT4N	equ	<000000008h>
D3DDTCAPS_USHORT2N	equ	<000000010h>
D3DDTCAPS_USHORT4N	equ	<000000020h>
D3DDTCAPS_UDEC3	equ	<000000040h>
D3DDTCAPS_DEC3N	equ	<000000080h>
D3DDTCAPS_FLOAT16_2	equ	<000000100h>
D3DDTCAPS_FLOAT16_4	equ	<000000200h>
;ECHO   pack()
ENDIF  ; (DIRECT3D_VERSION >= 0x0900) 
ENDIF  ; _d3d9CAPS_H_ 
