 ;==========================================================================;
;*  Copyright (C) Microsoft Corporation.  All Rights Reserved.
;*  File:       d3d9types.h
;*  Content:    Direct3D capabilities include file
;***************************************************************************/
IFNDEF _d3d9TYPES_H_
_d3d9TYPES_H_ equ
IFNDEF DIRECT3D_VERSION
DIRECT3D_VERSION	equ	<00900h>
ENDIF  ;DIRECT3D_VERSION
 ; include this file content only if compiling for DX9 interfaces
IF (COMPARE (DIRECT3D_VERSION,GE,00900h))
;Include \masm32\sdk\float.SDK
IF COMPARE (_MSC_VER,GE,1200)
;ECHO   warning(push)
ENDIF 
;ECHO   warning(disable:4201)  ; anonymous unions warning
IF DEFINED (_X86_) OR DEFINED (_IA64) 
;ECHO   pack(4)
ENDIF 
 ; D3DCOLOR is equivalent to D3DFMT_A8R8G8B8
IFNDEF D3DCOLOR_DEFINED
ENDIF 
 ; maps unsigned 8 bits/channel to D3DCOLOR
 ; maps floating point channels (0.f to 1.f range) to D3DCOLOR
IFNDEF D3DVECTOR_DEFINED

D3DVECTOR	STRUCT
	x DWORD ?
	y DWORD ?
	z DWORD ?

D3DVECTOR		ENDS

ENDIF 
IFNDEF D3DCOLORVALUE_DEFINED

D3DCOLORVALUE	STRUCT
	r DWORD ?
	g DWORD ?
	b DWORD ?
	a DWORD ?

D3DCOLORVALUE		ENDS

ENDIF 
IFNDEF D3DRECT_DEFINED

D3DRECT	STRUCT
	x1 DWORD ?
	y1 DWORD ?
	x2 DWORD ?
	y2 DWORD ?

D3DRECT		ENDS

ENDIF 
IFNDEF D3DMATRIX_DEFINED

D3DMATRIX	STRUCT
	union
	STRUCT
	_11 DWORD ?
	_21 DWORD ?
	_31 DWORD ?
	_41 DWORD ?
	ENDS
	m DWORD 4 dup (?)
	ENDS

D3DMATRIX		ENDS

ENDIF 

D3DVIEWPORT9	STRUCT
	X DWORD ?
	Y DWORD ?  ; Viewport Top left 
	Width1 DWORD ?
	Height DWORD ?  ; Viewport Dimensions 
	MinZ DWORD ?  ; Min/max of clip Volume 
	MaxZ DWORD ?

D3DVIEWPORT9		ENDS

 ;
;* Values for clip fields.
;*/
 ; Max number of user clipping planes, supported in D3D.
D3DMAXUSERCLIPPLANES	equ	<32>
 ; These bits could be ORed together to use with D3DRS_CLIPPLANEENABLE
 ;
D3DCLIPPLANE0	equ	<1 SHL  0>
D3DCLIPPLANE1	equ	<1 SHL  1>
D3DCLIPPLANE2	equ	<1 SHL  2>
D3DCLIPPLANE3	equ	<1 SHL  3>
D3DCLIPPLANE4	equ	<1 SHL  4>
D3DCLIPPLANE5	equ	<1 SHL  5>
 ; The following bits are used in the ClipUnion and ClipIntersection
 ; members of the D3DCLIPSTATUS9
 ;
D3DCS_LEFT	equ	<000000001h>
D3DCS_RIGHT	equ	<000000002h>
D3DCS_TOP	equ	<000000004h>
D3DCS_BOTTOM	equ	<000000008h>
D3DCS_FRONT	equ	<000000010h>
D3DCS_BACK	equ	<000000020h>
D3DCS_PLANE0	equ	<000000040h>
D3DCS_PLANE1	equ	<000000080h>
D3DCS_PLANE2	equ	<000000100h>
D3DCS_PLANE3	equ	<000000200h>
D3DCS_PLANE4	equ	<000000400h>
D3DCS_PLANE5	equ	<000000800h>
D3DCS_ALL	equ	<D3DCS_LEFT OR  D3DCS_RIGHT OR  D3DCS_TOP OR  D3DCS_BOTTOM OR  D3DCS_FRONT OR  D3DCS_BACK OR  D3DCS_PLANE0 OR  D3DCS_PLANE1 OR  D3DCS_PLANE2 OR  D3DCS_PLANE3 OR  D3DCS_PLANE4 OR  D3DCS_PLANE5>

D3DCLIPSTATUS9	STRUCT
	ClipUnion DWORD ?
	ClipIntersection DWORD ?

D3DCLIPSTATUS9		ENDS


D3DMATERIAL9	STRUCT
	Diffuse D3DCOLORVALUE <>   ; Diffuse color RGBA 
	Ambient D3DCOLORVALUE <>   ; Ambient color RGB 
	Specular D3DCOLORVALUE <>   ; Specular 'shininess' 
	Emissive D3DCOLORVALUE <>   ; Emissive color RGB 
	Power DWORD ?  ; Sharpness if specular highlight 

D3DMATERIAL9		ENDS


;D3DLIGHTTYPE	UNION
	D3DLIGHT_POINT	EQU 1 
	D3DLIGHT_SPOT	EQU 2 
	D3DLIGHT_DIRECTIONAL	EQU 3 
	D3DLIGHT_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DLIGHTTYPE		ENDS



D3DLIGHT9	STRUCT
	type1 DWORD ?  ; Type of light source 
	Diffuse D3DCOLORVALUE <>   ; Diffuse color of light 
	Specular D3DCOLORVALUE <>   ; Specular color of light 
	Ambient D3DCOLORVALUE <>   ; Ambient color of light 
	Position D3DVECTOR <>   ; Position in world space 
	Direction D3DVECTOR <>   ; Direction in world space 
	Range DWORD ?  ; Cutoff range 
	Falloff DWORD ?  ; Falloff 
	Attenuation0 DWORD ?  ; Constant attenuation 
	Attenuation1 DWORD ?  ; Linear attenuation 
	Attenuation2 DWORD ?  ; Quadratic attenuation 
	Theta DWORD ?  ; Inner angle of spotlight cone 
	Phi DWORD ?  ; Outer angle of spotlight cone 

D3DLIGHT9		ENDS

 ;
;* Options for clearing
;*/
D3DCLEAR_TARGET	equ	<000000001>
D3DCLEAR_ZBUFFER	equ	<000000002>
D3DCLEAR_STENCIL	equ	<000000004>
 ;
;* The following defines the rendering states
;*/

;D3DSHADEMODE	UNION
	D3DSHADE_FLAT	EQU 1 
	D3DSHADE_GOURAUD	EQU 2 
	D3DSHADE_PHONG	EQU 3 
	D3DSHADE_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DSHADEMODE		ENDS



;D3DFILLMODE	UNION
	D3DFILL_POINT	EQU 1 
	D3DFILL_WIREFRAME	EQU 2 
	D3DFILL_SOLID	EQU 3 
	D3DFILL_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DFILLMODE		ENDS



;D3DBLEND	UNION
	D3DBLEND_ZERO	EQU 1 
	D3DBLEND_ONE	EQU 2 
	D3DBLEND_SRCCOLOR	EQU 3 
	D3DBLEND_INVSRCCOLOR	EQU 4 
	D3DBLEND_SRCALPHA	EQU 5 
	D3DBLEND_INVSRCALPHA	EQU 6 
	D3DBLEND_DESTALPHA	EQU 7 
	D3DBLEND_INVDESTALPHA	EQU 8 
	D3DBLEND_DESTCOLOR	EQU 9 
	D3DBLEND_INVDESTCOLOR	EQU 10 
	D3DBLEND_SRCALPHASAT	EQU 11 
	D3DBLEND_BOTHSRCALPHA	EQU 12 
	D3DBLEND_BOTHINVSRCALPHA	EQU 13 
	D3DBLEND_BLENDFACTOR	EQU 14 	 ; Only supported if D3DPBLENDCAPS_BLENDFACTOR is on 
	D3DBLEND_INVBLENDFACTOR	EQU 15 	 ; Only supported if D3DPBLENDCAPS_BLENDFACTOR is on 
	D3DBLEND_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DBLEND		ENDS


;D3DBLENDOP	UNION
	D3DBLENDOP_ADD	EQU 1 
	D3DBLENDOP_SUBTRACT	EQU 2 
	D3DBLENDOP_REVSUBTRACT	EQU 3 
	D3DBLENDOP_MIN	EQU 4 
	D3DBLENDOP_MAX	EQU 5 
	D3DBLENDOP_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DBLENDOP		ENDS



;D3DTEXTUREADDRESS	UNION
	D3DTADDRESS_WRAP	EQU 1 
	D3DTADDRESS_MIRROR	EQU 2 
	D3DTADDRESS_CLAMP	EQU 3 
	D3DTADDRESS_BORDER	EQU 4 
	D3DTADDRESS_MIRRORONCE	EQU 5 
	D3DTADDRESS_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DTEXTUREADDRESS		ENDS



;D3DCULL	UNION
	D3DCULL_NONE	EQU 1 
	D3DCULL_CW	EQU 2 
	D3DCULL_CCW	EQU 3 
	D3DCULL_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DCULL		ENDS



;D3DCMPFUNC	UNION
	D3DCMP_NEVER	EQU 1 
	D3DCMP_LESS	EQU 2 
	D3DCMP_EQUAL	EQU 3 
	D3DCMP_LESSEQUAL	EQU 4 
	D3DCMP_GREATER	EQU 5 
	D3DCMP_NOTEQUAL	EQU 6 
	D3DCMP_GREATEREQUAL	EQU 7 
	D3DCMP_ALWAYS	EQU 8 
	D3DCMP_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DCMPFUNC		ENDS



;D3DSTENCILOP	UNION
	D3DSTENCILOP_KEEP	EQU 1 
	D3DSTENCILOP_ZERO	EQU 2 
	D3DSTENCILOP_REPLACE	EQU 3 
	D3DSTENCILOP_INCRSAT	EQU 4 
	D3DSTENCILOP_DECRSAT	EQU 5 
	D3DSTENCILOP_INVERT	EQU 6 
	D3DSTENCILOP_INCR	EQU 7 
	D3DSTENCILOP_DECR	EQU 8 
	D3DSTENCILOP_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DSTENCILOP		ENDS



;D3DFOGMODE	UNION
	D3DFOG_NONE	EQU 0 
	D3DFOG_EXP	EQU 1 
	D3DFOG_EXP2	EQU 2 
	D3DFOG_LINEAR	EQU 3 
	D3DFOG_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DFOGMODE		ENDS



;D3DZBUFFERTYPE	UNION
	D3DZB_FALSE	EQU 0 
	D3DZB_TRUE	EQU 1 	 ; Z buffering
	D3DZB_USEW	EQU 2 	 ; W buffering
	D3DZB_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DZBUFFERTYPE		ENDS


 ; Primitives supported by draw-primitive API

;D3DPRIMITIVETYPE	UNION
	D3DPT_POINTLIST	EQU 1 
	D3DPT_LINELIST	EQU 2 
	D3DPT_LINESTRIP	EQU 3 
	D3DPT_TRIANGLELIST	EQU 4 
	D3DPT_TRIANGLESTRIP	EQU 5 
	D3DPT_TRIANGLEFAN	EQU 6 
	D3DPT_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DPRIMITIVETYPE		ENDS



;D3DTRANSFORMSTATETYPE	UNION
	D3DTS_VIEW	EQU 2 
	D3DTS_PROJECTION	EQU 3 
	D3DTS_TEXTURE0	EQU 16 
	D3DTS_TEXTURE1	EQU 17 
	D3DTS_TEXTURE2	EQU 18 
	D3DTS_TEXTURE3	EQU 19 
	D3DTS_TEXTURE4	EQU 20 
	D3DTS_TEXTURE5	EQU 21 
	D3DTS_TEXTURE6	EQU 22 
	D3DTS_TEXTURE7	EQU 23 
	D3DTS_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DTRANSFORMSTATETYPE		ENDS

 D3DTS_WORLDMATRIX equ 256
 D3DTS_WORLD 	equ D3DTS_WORLDMATRIX +0
 D3DTS_WORLD1 	equ D3DTS_WORLDMATRIX +1
 D3DTS_WORLD2 	equ D3DTS_WORLDMATRIX +2
 D3DTS_WORLD3 	equ D3DTS_WORLDMATRIX +3




;D3DRENDERSTATETYPE	UNION
	D3DRS_ZENABLE	EQU 7 	 ; D3DZBUFFERTYPE (or TRUE/FALSE for legacy) 
	D3DRS_FILLMODE	EQU 8 	 ; D3DFILLMODE 
	D3DRS_SHADEMODE	EQU 9 	 ; D3DSHADEMODE 
	D3DRS_ZWRITEENABLE	EQU 14 	 ; TRUE to enable z writes 
	D3DRS_ALPHATESTENABLE	EQU 15 	 ; TRUE to enable alpha tests 
	D3DRS_LASTPIXEL	EQU 16 	 ; TRUE for last-pixel on lines 
	D3DRS_SRCBLEND	EQU 19 	 ; D3DBLEND 
	D3DRS_DESTBLEND	EQU 20 	 ; D3DBLEND 
	D3DRS_CULLMODE	EQU 22 	 ; D3DCULL 
	D3DRS_ZFUNC	EQU 23 	 ; D3DCMPFUNC 
	D3DRS_ALPHAREF	EQU 24 	 ; D3DFIXED 
	D3DRS_ALPHAFUNC	EQU 25 	 ; D3DCMPFUNC 
	D3DRS_DITHERENABLE	EQU 26 	 ; TRUE to enable dithering 
	D3DRS_ALPHABLENDENABLE	EQU 27 	 ; TRUE to enable alpha blending 
	D3DRS_FOGENABLE	EQU 28 	 ; TRUE to enable fog blending 
	D3DRS_SPECULARENABLE	EQU 29 	 ; TRUE to enable specular 
	D3DRS_FOGCOLOR	EQU 34 	 ; D3DCOLOR 
	D3DRS_FOGTABLEMODE	EQU 35 	 ; D3DFOGMODE 
	D3DRS_FOGSTART	EQU 36 	 ; Fog start (for both vertex and pixel fog) 
	D3DRS_FOGEND	EQU 37 	 ; Fog end      
	D3DRS_FOGDENSITY	EQU 38 	 ; Fog density  
	D3DRS_RANGEFOGENABLE	EQU 48 	 ; Enables range-based fog 
	D3DRS_STENCILENABLE	EQU 52 	 ; BOOL enable/disable stenciling 
	D3DRS_STENCILFAIL	EQU 53 	 ; D3DSTENCILOP to do if stencil test fails 
	D3DRS_STENCILZFAIL	EQU 54 	 ; D3DSTENCILOP to do if stencil test passes and Z test fails 
	D3DRS_STENCILPASS	EQU 55 	 ; D3DSTENCILOP to do if both stencil and Z tests pass 
	D3DRS_STENCILFUNC	EQU 56 	 ; D3DCMPFUNC fn.  Stencil Test passes if ((ref & mask) stencilfn (stencil & mask)) is true 
	D3DRS_STENCILREF	EQU 57 	 ; Reference value used in stencil test 
	D3DRS_STENCILMASK	EQU 58 	 ; Mask value used in stencil test 
	D3DRS_STENCILWRITEMASK	EQU 59 	 ; Write mask applied to values written to stencil buffer 
	D3DRS_TEXTUREFACTOR	EQU 60 	 ; D3DCOLOR used for multi-texture blend 
	D3DRS_WRAP0	EQU 128 	 ; wrap for 1st texture coord. set 
	D3DRS_WRAP1	EQU 129 	 ; wrap for 2nd texture coord. set 
	D3DRS_WRAP2	EQU 130 	 ; wrap for 3rd texture coord. set 
	D3DRS_WRAP3	EQU 131 	 ; wrap for 4th texture coord. set 
	D3DRS_WRAP4	EQU 132 	 ; wrap for 5th texture coord. set 
	D3DRS_WRAP5	EQU 133 	 ; wrap for 6th texture coord. set 
	D3DRS_WRAP6	EQU 134 	 ; wrap for 7th texture coord. set 
	D3DRS_WRAP7	EQU 135 	 ; wrap for 8th texture coord. set 
	D3DRS_CLIPPING	EQU 136 
	D3DRS_LIGHTING	EQU 137 
	D3DRS_AMBIENT	EQU 139 
	D3DRS_FOGVERTEXMODE	EQU 140 
	D3DRS_COLORVERTEX	EQU 141 
	D3DRS_LOCALVIEWER	EQU 142 
	D3DRS_NORMALIZENORMALS	EQU 143 
	D3DRS_DIFFUSEMATERIALSOURCE	EQU 145 
	D3DRS_SPECULARMATERIALSOURCE	EQU 146 
	D3DRS_AMBIENTMATERIALSOURCE	EQU 147 
	D3DRS_EMISSIVEMATERIALSOURCE	EQU 148 
	D3DRS_VERTEXBLEND	EQU 151 
	D3DRS_CLIPPLANEENABLE	EQU 152 
	D3DRS_POINTSIZE	EQU 154 	 ; float point size 
	D3DRS_POINTSIZE_MIN	EQU 155 	 ; float point size min threshold 
	D3DRS_POINTSPRITEENABLE	EQU 156 	 ; BOOL point texture coord control 
	D3DRS_POINTSCALEENABLE	EQU 157 	 ; BOOL point size scale enable 
	D3DRS_POINTSCALE_A	EQU 158 	 ; float point attenuation A value 
	D3DRS_POINTSCALE_B	EQU 159 	 ; float point attenuation B value 
	D3DRS_POINTSCALE_C	EQU 160 	 ; float point attenuation C value 
	D3DRS_MULTISAMPLEANTIALIAS	EQU 161 	 ; BOOL - set to do FSAA with multisample buffer
	D3DRS_MULTISAMPLEMASK	EQU 162 	 ; DWORD - per-sample enable/disable
	D3DRS_PATCHEDGESTYLE	EQU 163 	 ; Sets whether patch edges will use float style tessellation
	D3DRS_DEBUGMONITORTOKEN	EQU 165 	 ; DEBUG ONLY - token to debug monitor
	D3DRS_POINTSIZE_MAX	EQU 166 	 ; float point size max threshold 
	D3DRS_INDEXEDVERTEXBLENDENABLE	EQU 167 
	D3DRS_COLORWRITEENABLE	EQU 168 	 ; per-channel write enable
	D3DRS_TWEENFACTOR	EQU 170 	 ; float tween factor
	D3DRS_BLENDOP	EQU 171 	 ; D3DBLENDOP setting
	D3DRS_POSITIONDEGREE	EQU 172 	 ; NPatch position interpolation degree. D3DDEGREE_LINEAR or D3DDEGREE_CUBIC (default)
	D3DRS_NORMALDEGREE	EQU 173 	 ; NPatch normal interpolation degree. D3DDEGREE_LINEAR (default) or D3DDEGREE_QUADRATIC
	D3DRS_SCISSORTESTENABLE	EQU 174 
	D3DRS_SLOPESCALEDEPTHBIAS	EQU 175 
	D3DRS_ANTIALIASEDLINEENABLE	EQU 176 
	D3DRS_MINTESSELLATIONLEVEL	EQU 178 
	D3DRS_MAXTESSELLATIONLEVEL	EQU 179 
	D3DRS_ADAPTIVETESS_X	EQU 180 
	D3DRS_ADAPTIVETESS_Y	EQU 181 
	D3DRS_ADAPTIVETESS_Z	EQU 182 
	D3DRS_ADAPTIVETESS_W	EQU 183 
	D3DRS_ENABLEADAPTIVETESSELLATION	EQU 184 
	D3DRS_TWOSIDEDSTENCILMODE	EQU 185 	 ; BOOL enable/disable 2 sided stenciling 
	D3DRS_CCW_STENCILFAIL	EQU 186 	 ; D3DSTENCILOP to do if ccw stencil test fails 
	D3DRS_CCW_STENCILZFAIL	EQU 187 	 ; D3DSTENCILOP to do if ccw stencil test passes and Z test fails 
	D3DRS_CCW_STENCILPASS	EQU 188 	 ; D3DSTENCILOP to do if both ccw stencil and Z tests pass 
	D3DRS_CCW_STENCILFUNC	EQU 189 	 ; D3DCMPFUNC fn.  ccw Stencil Test passes if ((ref & mask) stencilfn (stencil & mask)) is true 
	D3DRS_COLORWRITEENABLE1	EQU 190 	 ; Additional ColorWriteEnables for the devices that support D3DPMISCCAPS_INDEPENDENTWRITEMASKS 
	D3DRS_COLORWRITEENABLE2	EQU 191 	 ; Additional ColorWriteEnables for the devices that support D3DPMISCCAPS_INDEPENDENTWRITEMASKS 
	D3DRS_COLORWRITEENABLE3	EQU 192 	 ; Additional ColorWriteEnables for the devices that support D3DPMISCCAPS_INDEPENDENTWRITEMASKS 
	D3DRS_BLENDFACTOR	EQU 193 	 ; D3DCOLOR used for a constant blend factor during alpha blending for devices that support D3DPBLENDCAPS_BLENDFACTOR 
	D3DRS_SRGBWRITEENABLE	EQU 194 	 ; Enable rendertarget writes to be DE-linearized to SRGB (for formats that expose D3DUSAGE_QUERY_SRGBWRITE) 
	D3DRS_DEPTHBIAS	EQU 195 
	D3DRS_WRAP8	EQU 198 	 ; Additional wrap states for vs_3_0+ attributes with D3DDECLUSAGE_TEXCOORD 
	D3DRS_WRAP9	EQU 199 
	D3DRS_WRAP10	EQU 200 
	D3DRS_WRAP11	EQU 201 
	D3DRS_WRAP12	EQU 202 
	D3DRS_WRAP13	EQU 203 
	D3DRS_WRAP14	EQU 204 
	D3DRS_WRAP15	EQU 205 
	D3DRS_SEPARATEALPHABLENDENABLE	EQU 206 	 ; TRUE to enable a separate blending function for the alpha channel 
	D3DRS_SRCBLENDALPHA	EQU 207 	 ; SRC blend factor for the alpha channel when D3DRS_SEPARATEDESTALPHAENABLE is TRUE 
	D3DRS_DESTBLENDALPHA	EQU 208 	 ; DST blend factor for the alpha channel when D3DRS_SEPARATEDESTALPHAENABLE is TRUE 
	D3DRS_BLENDOPALPHA	EQU 209 	 ; Blending operation for the alpha channel when D3DRS_SEPARATEDESTALPHAENABLE is TRUE 
	D3DRS_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DRENDERSTATETYPE		ENDS

 ; Maximum number of simultaneous render targets D3D supports
D3D_MAX_SIMULTANEOUS_RENDERTARGETS	equ	<4>
 ; Values for material source

;D3DMATERIALCOLORSOURCE	UNION
	D3DMCS_MATERIAL	EQU 0 	 ; Color from material is used
	D3DMCS_COLOR1	EQU 1 	 ; Diffuse vertex color is used
	D3DMCS_COLOR2	EQU 2 	 ; Specular vertex color is used
	D3DMCS_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DMATERIALCOLORSOURCE		ENDS


 ; Bias to apply to the texture coordinate set to apply a wrap to.
D3DRENDERSTATE_WRAPBIAS	equ	<128>
 ; Flags to construct the WRAP render states 
D3DWRAP_U	equ	<000000001h>
D3DWRAP_V	equ	<000000002h>
D3DWRAP_W	equ	<000000004h>
 ; Flags to construct the WRAP render states for 1D thru 4D texture coordinates 
D3DWRAPCOORD_0	equ	<000000001h>
D3DWRAPCOORD_1	equ	<000000002h>
D3DWRAPCOORD_2	equ	<000000004h>
D3DWRAPCOORD_3	equ	<000000008h>
 ; Flags to construct D3DRS_COLORWRITEENABLE 
 ;
;* State enumerants for per-stage processing of fixed function pixel processing
;* Two of these affect fixed function vertex processing as well: TEXTURETRANSFORMFLAGS and TEXCOORDINDEX.
;*/

;D3DTEXTURESTAGESTATETYPE	UNION
	D3DTSS_COLOROP	EQU 1 	 ; D3DTEXTUREOP - per-stage blending controls for color channels 
	D3DTSS_COLORARG1	EQU 2 	 ; D3DTA_
	D3DTSS_COLORARG2	EQU 3 	 ; D3DTA_
	D3DTSS_ALPHAOP	EQU 4 	 ; D3DTEXTUREOP - per-stage blending controls for alpha channel 
	D3DTSS_ALPHAARG1	EQU 5 	 ; D3DTA_
	D3DTSS_ALPHAARG2	EQU 6 	 ; D3DTA_
	D3DTSS_BUMPENVMAT00	EQU 7 	 ; float (bump mapping matrix) 
	D3DTSS_BUMPENVMAT01	EQU 8 	 ; float (bump mapping matrix) 
	D3DTSS_BUMPENVMAT10	EQU 9 	 ; float (bump mapping matrix) 
	D3DTSS_BUMPENVMAT11	EQU 10 	 ; float (bump mapping matrix) 
	D3DTSS_TEXCOORDINDEX	EQU 11 	 ; identifies which set of texture coordinates index this texture 
	D3DTSS_BUMPENVLSCALE	EQU 22 	 ; float scale for bump map luminance 
	D3DTSS_BUMPENVLOFFSET	EQU 23 	 ; float offset for bump map luminance 
	D3DTSS_TEXTURETRANSFORMFLAGS	EQU 24 	 ; D3DTEXTURETRANSFORMFLAGS controls texture transform 
	D3DTSS_COLORARG0	EQU 26 	 ; D3DTA_
	D3DTSS_ALPHAARG0	EQU 27 	 ; D3DTA_
	D3DTSS_RESULTARG	EQU 28 	 ; D3DTA_
	D3DTSS_CONSTANT	EQU 32 	 ; Per-stage constant D3DTA_CONSTANT 
	D3DTSS_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DTEXTURESTAGESTATETYPE		ENDS

 ;
;* State enumerants for per-sampler texture processing.
;*/

;D3DSAMPLERSTATETYPE	UNION
	D3DSAMP_ADDRESSU	EQU 1 	 ; D3DTEXTUREADDRESS for U coordinate 
	D3DSAMP_ADDRESSV	EQU 2 	 ; D3DTEXTUREADDRESS for V coordinate 
	D3DSAMP_ADDRESSW	EQU 3 	 ; D3DTEXTUREADDRESS for W coordinate 
	D3DSAMP_BORDERCOLOR	EQU 4 	 ; D3DCOLOR 
	D3DSAMP_MAGFILTER	EQU 5 	 ; D3DTEXTUREFILTER filter to use for magnification 
	D3DSAMP_MINFILTER	EQU 6 	 ; D3DTEXTUREFILTER filter to use for minification 
	D3DSAMP_MIPFILTER	EQU 7 	 ; D3DTEXTUREFILTER filter to use between mipmaps during minification 
	D3DSAMP_MIPMAPLODBIAS	EQU 8 	 ; float Mipmap LOD bias 
	D3DSAMP_MAXMIPLEVEL	EQU 9 	 ; DWORD 0..(n-1) LOD index of largest map to use (0 == largest) 
	D3DSAMP_MAXANISOTROPY	EQU 10 	 ; DWORD maximum anisotropy 
	D3DSAMP_SRGBTEXTURE	EQU 11 	 ; Default = 0 (which means Gamma 1.0,
	D3DSAMP_ELEMENTINDEX	EQU 12 	 ; When multi-element texture is assigned to sampler, this
	D3DSAMP_DMAPOFFSET	EQU 13 	 ; Offset in vertices in the pre-sampled displacement map.
	D3DSAMP_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DSAMPLERSTATETYPE		ENDS

 ; Special sampler which is used in the tesselator 
D3DDMAPSAMPLER	equ	<256>
 ; Samplers used in vertex shaders
D3DVERTEXTEXTURESAMPLER0	equ	<D3DDMAPSAMPLER +  1>
D3DVERTEXTEXTURESAMPLER1	equ	<D3DDMAPSAMPLER +  2>
D3DVERTEXTEXTURESAMPLER2	equ	<D3DDMAPSAMPLER +  3>
D3DVERTEXTEXTURESAMPLER3	equ	<D3DDMAPSAMPLER +  4>
 ; Values, used with D3DTSS_TEXCOORDINDEX, to specify that the vertex data(position
 ; and normal in the camera space) should be taken as texture coordinates
 ; Low 16 bits are used to specify texture coordinate index, to take the WRAP mode from
 ;
D3DTSS_TCI_PASSTHRU	equ	<000000000h>
D3DTSS_TCI_CAMERASPACENORMAL	equ	<000010000h>
D3DTSS_TCI_CAMERASPACEPOSITION	equ	<000020000h>
D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR	equ	<000030000h>
D3DTSS_TCI_SPHEREMAP	equ	<000040000h>
 ;
;* Enumerations for COLOROP and ALPHAOP texture blending operations set in
;* texture processing stage controls in D3DTSS.
;*/

;D3DTEXTUREOP	UNION
	D3DTOP_DISABLE	EQU 1 	 ; disables stage
	D3DTOP_SELECTARG1	EQU 2 	 ; the default
	D3DTOP_SELECTARG2	EQU 3 
	D3DTOP_MODULATE	EQU 4 	 ; multiply args together
	D3DTOP_MODULATE2X	EQU 5 	 ; multiply and  1 bit
	D3DTOP_MODULATE4X	EQU 6 	 ; multiply and  2 bits
	D3DTOP_ADD	EQU 7 	 ; add arguments together
	D3DTOP_ADDSIGNED	EQU 8 	 ; add with -0.5 bias
	D3DTOP_ADDSIGNED2X	EQU 9 	 ; as above but left  1 bit
	D3DTOP_SUBTRACT	EQU 10 	 ; Arg1 - Arg2, with no saturation
	D3DTOP_ADDSMOOTH	EQU 11 	 ; add 2 args, subtract product
	D3DTOP_BLENDDIFFUSEALPHA	EQU 12 	 ; iterated alpha
	D3DTOP_BLENDTEXTUREALPHA	EQU 13 	 ; texture alpha
	D3DTOP_BLENDFACTORALPHA	EQU 14 	 ; alpha from D3DRS_TEXTUREFACTOR
	D3DTOP_BLENDTEXTUREALPHAPM	EQU 15 	 ; texture alpha
	D3DTOP_BLENDCURRENTALPHA	EQU 16 	 ; by alpha of current color
	D3DTOP_PREMODULATE	EQU 17 	 ; modulate with next texture before use
	D3DTOP_MODULATEALPHA_ADDCOLOR	EQU 18 	 ; Arg1.RGB + Arg1.A*Arg2.RGB
	D3DTOP_MODULATECOLOR_ADDALPHA	EQU 19 	 ; Arg1.RGB*Arg2.RGB + Arg1.A
	D3DTOP_MODULATEINVALPHA_ADDCOLOR	EQU 20 	 ; (1-Arg1.A)*Arg2.RGB + Arg1.RGB
	D3DTOP_MODULATEINVCOLOR_ADDALPHA	EQU 21 	 ; (1-Arg1.RGB)*Arg2.RGB + Arg1.A
	D3DTOP_BUMPENVMAP	EQU 22 	 ; per pixel env map perturbation
	D3DTOP_BUMPENVMAPLUMINANCE	EQU 23 	 ; with luminance channel
	D3DTOP_DOTPRODUCT3	EQU 24 
	D3DTOP_MULTIPLYADD	EQU 25 	 ; Arg0 + Arg1*Arg2
	D3DTOP_LERP	EQU 26 	 ; (Arg0)*Arg1 + (1-Arg0)*Arg2
	D3DTOP_FORCE_DWORD	EQU 07fffffffh 
;D3DTEXTUREOP		ENDS

 ;
;* Values for COLORARG0,1,2, ALPHAARG0,1,2, and RESULTARG texture blending
;* operations set in texture processing stage controls in D3DRENDERSTATE.
;*/
D3DTA_SELECTMASK	equ	<00000000fh>
D3DTA_DIFFUSE	equ	<000000000h>
D3DTA_CURRENT	equ	<000000001h>
D3DTA_TEXTURE	equ	<000000002h>
D3DTA_TFACTOR	equ	<000000003h>
D3DTA_SPECULAR	equ	<000000004h>
D3DTA_TEMP	equ	<000000005h>
D3DTA_CONSTANT	equ	<000000006h>
D3DTA_COMPLEMENT	equ	<000000010h>
D3DTA_ALPHAREPLICATE	equ	<000000020h>
 ;
 ; Values for D3DSAMP_***FILTER texture stage states
 ;

;D3DTEXTUREFILTERTYPE	UNION
	D3DTEXF_NONE	EQU 0 	 ; filtering disabled (valid for mip filter only)
	D3DTEXF_POINT	EQU 1 	 ; nearest
	D3DTEXF_LINEAR	EQU 2 	 ; linear interpolation
	D3DTEXF_ANISOTROPIC	EQU 3 	 ; anisotropic
	D3DTEXF_PYRAMIDALQUAD	EQU 6 	 ; 4-sample tent
	D3DTEXF_GAUSSIANQUAD	EQU 7 	 ; 4-sample gaussian
	D3DTEXF_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DTEXTUREFILTERTYPE		ENDS


 ; Bits for Flags in ProcessVertices call 
D3DPV_DONOTCOPYDATA	equ	<1 SHL  0>
 ;-------------------------------------------------------------------
 ; Flexible vertex format bits
 ;
D3DFVF_RESERVED0	equ	<0001h>
D3DFVF_POSITION_MASK	equ	<0400Eh>
D3DFVF_XYZ	equ	<0002h>
D3DFVF_XYZRHW	equ	<0004h>
D3DFVF_XYZB1	equ	<0006h>
D3DFVF_XYZB2	equ	<0008h>
D3DFVF_XYZB3	equ	<000ah>
D3DFVF_XYZB4	equ	<000ch>
D3DFVF_XYZB5	equ	<000eh>
D3DFVF_XYZW	equ	<04002h>
D3DFVF_NORMAL	equ	<0010h>
D3DFVF_PSIZE	equ	<0020h>
D3DFVF_DIFFUSE	equ	<0040h>
D3DFVF_SPECULAR	equ	<0080h>
D3DFVF_TEXCOUNT_MASK	equ	<0f00h>
D3DFVF_TEXCOUNT_SHIFT	equ	<8>
D3DFVF_TEX0	equ	<0000h>
D3DFVF_TEX1	equ	<0100h>
D3DFVF_TEX2	equ	<0200h>
D3DFVF_TEX3	equ	<0300h>
D3DFVF_TEX4	equ	<0400h>
D3DFVF_TEX5	equ	<0500h>
D3DFVF_TEX6	equ	<0600h>
D3DFVF_TEX7	equ	<0700h>
D3DFVF_TEX8	equ	<0800h>
D3DFVF_LASTBETA_UBYTE4	equ	<01000h>
D3DFVF_LASTBETA_D3DCOLOR	equ	<08000h>
D3DFVF_RESERVED2	equ	<06000h>
 ;---------------------------------------------------------------------
 ; Vertex Shaders
 ;
 ; Vertex shader declaration
 ; Vertex element semantics
 ;

;D3DDECLUSAGE	UNION
	D3DDECLUSAGE_POSITION	EQU 0 
	D3DDECLUSAGE_BLENDWEIGHT	EQU 01H	 ; 1
	D3DDECLUSAGE_BLENDINDICES	EQU 02H	 ; 2
	D3DDECLUSAGE_NORMAL	EQU 03H	 ; 3
	D3DDECLUSAGE_PSIZE	EQU 04H	 ; 4
	D3DDECLUSAGE_TEXCOORD	EQU 05H	 ; 5
	D3DDECLUSAGE_TANGENT	EQU 06H	 ; 6
	D3DDECLUSAGE_BINORMAL	EQU 07H	 ; 7
	D3DDECLUSAGE_TESSFACTOR	EQU 08H	 ; 8
	D3DDECLUSAGE_POSITIONT	EQU 09H	 ; 9
	D3DDECLUSAGE_COLOR	EQU 0AH	 ; 10
	D3DDECLUSAGE_FOG	EQU 0BH	 ; 11
	D3DDECLUSAGE_DEPTH	EQU 0CH	 ; 12
	D3DDECLUSAGE_SAMPLE	EQU 0DH	 ; 13
;D3DDECLUSAGE		ENDS

MAXD3DDECLUSAGE	equ	<D3DDECLUSAGE_SAMPLE>
MAXD3DDECLUSAGEINDEX	equ	<15>
MAXD3DDECLLENGTH	equ	<64>

;D3DDECLMETHOD	UNION
	D3DDECLMETHOD_DEFAULT	EQU 0 
	D3DDECLMETHOD_PARTIALU	EQU 01H
	D3DDECLMETHOD_PARTIALV	EQU 02H
	D3DDECLMETHOD_CROSSUV	EQU 03H	 ; Normal
	D3DDECLMETHOD_UV	EQU 04H
	D3DDECLMETHOD_LOOKUP	EQU 05H	 ; Lookup a displacement map
	D3DDECLMETHOD_LOOKUPPRESAMPLED	EQU 06H	 ; Lookup a pre-sampled displacement map
;D3DDECLMETHOD		ENDS


MAXD3DDECLMETHOD	equ	<D3DDECLMETHOD_LOOKUPPRESAMPLED>
 ; Declarations for _Type fields
 ;

;D3DDECLTYPE	UNION
	D3DDECLTYPE_FLOAT1	EQU 0 	 ; 1D float expanded to (value, 0., 0., 1.)
	D3DDECLTYPE_FLOAT2	EQU 1 	 ; 2D float expanded to (value, value, 0., 1.)
	D3DDECLTYPE_FLOAT3	EQU 2 	 ; 3D float expanded to (value, value, value, 1.)
	D3DDECLTYPE_FLOAT4	EQU 3 	 ; 4D float
	D3DDECLTYPE_D3DCOLOR	EQU 4 	 ; 4D packed unsigned bytes mapped to 0. to 1. range
	D3DDECLTYPE_UBYTE4	EQU 5 	 ; 4D unsigned byte
	D3DDECLTYPE_SHORT2	EQU 6 	 ; 2D signed short expanded to (value, value, 0., 1.)
	D3DDECLTYPE_SHORT4	EQU 7 	 ; 4D signed short
	D3DDECLTYPE_UBYTE4N	EQU 8 	 ; Each of 4 bytes is normalized by dividing to 255.0
	D3DDECLTYPE_SHORT2N	EQU 9 	 ; 2D signed short normalized (v[0]/32767.0,v[1]/32767.0,0,1)
	D3DDECLTYPE_SHORT4N	EQU 10 	 ; 4D signed short normalized (v[0]/32767.0,v[1]/32767.0,v[2]/32767.0,v[3]/32767.0)
	D3DDECLTYPE_USHORT2N	EQU 11 	 ; 2D unsigned short normalized (v[0]/65535.0,v[1]/65535.0,0,1)
	D3DDECLTYPE_USHORT4N	EQU 12 	 ; 4D unsigned short normalized (v[0]/65535.0,v[1]/65535.0,v[2]/65535.0,v[3]/65535.0)
	D3DDECLTYPE_UDEC3	EQU 13 	 ; 3D unsigned 10 10 10 format expanded to (value, value, value, 1)
	D3DDECLTYPE_DEC3N	EQU 14 	 ; 3D signed 10 10 10 format normalized and expanded to (v[0]/511.0, v[1]/511.0, v[2]/511.0, 1)
	D3DDECLTYPE_FLOAT16_2	EQU 15 	 ; Two 16-bit floating point values, expanded to (value, value, 0, 1)
	D3DDECLTYPE_FLOAT16_4	EQU 16 	 ; Four 16-bit floating point values
	D3DDECLTYPE_UNUSED	EQU 17 	 ; When the type field in a decl is unused.
;D3DDECLTYPE		ENDS

MAXD3DDECLTYPE	equ	<D3DDECLTYPE_UNUSED>

D3DVERTEXELEMENT9	STRUCT
	Stream WORD ?  ; Stream index
	offset1 WORD ?  ; Offset in the stream in bytes
	type1 BYTE ?  ; Data type
	Method BYTE ?  ; Processing method
	Usage BYTE ?  ; Semantics
	UsageIndex BYTE ?  ; Semantic index

D3DVERTEXELEMENT9		ENDS

 ; This is used to initialize the last vertex element in a vertex declaration
 ; array
 ;
 ; Maximum supported number of texture coordinate sets
D3DDP_MAXTEXCOORD	equ	<8>
 ;---------------------------------------------------------------------
 ;
 ; The internal format of Pixel Shader (PS) & Vertex Shader (VS)
 ; Instruction Tokens is defined in the Direct3D Device Driver Kit
 ;
 ;---------------------------------------------------------------------
 ;
 ; Instruction Token Bit Definitions
 ;
D3DSI_OPCODE_MASK	equ	<00000FFFFh>
D3DSI_INSTLENGTH_MASK	equ	<00F000000h>
D3DSI_INSTLENGTH_SHIFT	equ	<24>

;D3DSHADER_INSTRUCTION_OPCODE_TYPE	UNION
	D3DSIO_NOP	EQU 0 
	D3DSIO_MOV	EQU 01H
	D3DSIO_ADD	EQU 02H
	D3DSIO_SUB	EQU 03H
	D3DSIO_MAD	EQU 04H
	D3DSIO_MUL	EQU 05H
	D3DSIO_RCP	EQU 06H
	D3DSIO_RSQ	EQU 07H
	D3DSIO_DP3	EQU 08H
	D3DSIO_DP4	EQU 09H
	D3DSIO_MIN	EQU 0AH
	D3DSIO_MAX	EQU 0BH
	D3DSIO_SLT	EQU 0CH
	D3DSIO_SGE	EQU 0DH
	D3DSIO_EXP	EQU 0EH
	D3DSIO_LOG	EQU 0FH
	D3DSIO_LIT	EQU 010H
	D3DSIO_DST	EQU 011H
	D3DSIO_LRP	EQU 012H
	D3DSIO_FRC	EQU 013H
	D3DSIO_M4x4	EQU 014H
	D3DSIO_M4x3	EQU 015H
	D3DSIO_M3x4	EQU 016H
	D3DSIO_M3x3	EQU 017H
	D3DSIO_M3x2	EQU 018H
	D3DSIO_CALL	EQU 019H
	D3DSIO_CALLNZ	EQU 01AH
	D3DSIO_LOOP	EQU 01BH
	D3DSIO_RET	EQU 01CH
	D3DSIO_ENDLOOP	EQU 01DH
	D3DSIO_LABEL	EQU 01EH
	D3DSIO_DCL	EQU 01FH
	D3DSIO_POW	EQU 020H
	D3DSIO_CRS	EQU 021H
	D3DSIO_SGN	EQU 022H
	D3DSIO_ABS	EQU 023H
	D3DSIO_NRM	EQU 024H
	D3DSIO_SINCOS	EQU 025H
	D3DSIO_REP	EQU 026H
	D3DSIO_ENDREP	EQU 027H
	D3DSIO_IF	EQU 028H
	D3DSIO_IFC	EQU 029H
	D3DSIO_ELSE	EQU 02AH
	D3DSIO_ENDIF	EQU 02BH
	D3DSIO_BREAK	EQU 02CH
	D3DSIO_BREAKC	EQU 02DH
	D3DSIO_MOVA	EQU 02EH
	D3DSIO_DEFB	EQU 02FH
	D3DSIO_DEFI	EQU 030H
	D3DSIO_TEXCOORD	EQU 64 
	D3DSIO_TEXKILL	EQU 041H
	D3DSIO_TEX	EQU 042H
	D3DSIO_TEXBEM	EQU 043H
	D3DSIO_TEXBEML	EQU 044H
	D3DSIO_TEXREG2AR	EQU 045H
	D3DSIO_TEXREG2GB	EQU 046H
	D3DSIO_TEXM3x2PAD	EQU 047H
	D3DSIO_TEXM3x2TEX	EQU 048H
	D3DSIO_TEXM3x3PAD	EQU 049H
	D3DSIO_TEXM3x3TEX	EQU 04AH
	D3DSIO_RESERVED0	EQU 04BH
	D3DSIO_TEXM3x3SPEC	EQU 04CH
	D3DSIO_TEXM3x3VSPEC	EQU 04DH
	D3DSIO_EXPP	EQU 04EH
	D3DSIO_LOGP	EQU 04FH
	D3DSIO_CND	EQU 050H
	D3DSIO_DEF	EQU 051H
	D3DSIO_TEXREG2RGB	EQU 052H
	D3DSIO_TEXDP3TEX	EQU 053H
	D3DSIO_TEXM3x2DEPTH	EQU 054H
	D3DSIO_TEXDP3	EQU 055H
	D3DSIO_TEXM3x3	EQU 056H
	D3DSIO_TEXDEPTH	EQU 057H
	D3DSIO_CMP	EQU 058H
	D3DSIO_BEM	EQU 059H
	D3DSIO_DP2ADD	EQU 05AH
	D3DSIO_DSX	EQU 05BH
	D3DSIO_DSY	EQU 05CH
	D3DSIO_TEXLDD	EQU 05DH
	D3DSIO_SETP	EQU 05EH
	D3DSIO_TEXLDL	EQU 05FH
	D3DSIO_BREAKP	EQU 060H
	D3DSIO_PHASE	EQU 0FFFDh 
	D3DSIO_COMMENT	EQU 0FFFEh 
	D3DSIO_END	EQU 0FFFFh 
	D3DSIO_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DSHADER_INSTRUCTION_OPCODE_TYPE		ENDS

 ;---------------------------------------------------------------------
 ; Use these constants with D3DSIO_SINCOS macro as SRC2, SRC3
 ;
 ;---------------------------------------------------------------------
 ; Co-Issue Instruction Modifier - if set then this instruction is to be
 ; issued in parallel with the previous instruction(s) for which this bit
 ; is not set.
 ;
D3DSI_COISSUE	equ	<040000000h>
 ;---------------------------------------------------------------------
 ; Opcode specific controls
D3DSP_OPCODESPECIFICCONTROL_MASK	equ	<000ff0000h>
D3DSP_OPCODESPECIFICCONTROL_SHIFT	equ	<16>
 ; ps_2_0 texld controls
D3DSI_TEXLD_PROJECT	equ	<001h SHL  D3DSP_OPCODESPECIFICCONTROL_SHIFT>
D3DSI_TEXLD_BIAS	equ	<002h SHL  D3DSP_OPCODESPECIFICCONTROL_SHIFT>
 ; Comparison for dynamic conditional instruction opcodes (i.e. if, breakc)

;D3DSHADER_COMPARISON	UNION
	D3DSPC_RESERVED0	EQU 0 	 ; 0 0 0
	D3DSPC_GT	EQU 1 	 ; 0 0 1
	D3DSPC_EQ	EQU 2 	 ; 0 1 0
	D3DSPC_GE	EQU 3 	 ; 0 1 1
	D3DSPC_LT	EQU 4 	 ; 1 0 0
	D3DSPC_NE	EQU 5 	 ; 1 0 1
	D3DSPC_LE	EQU 6 	 ; 1 1 0
	D3DSPC_RESERVED1	EQU 7 	 ; 1 1 1
;D3DSHADER_COMPARISON		ENDS


 ; Comparison is part of instruction opcode token:
D3DSHADER_COMPARISON_SHIFT	equ	<D3DSP_OPCODESPECIFICCONTROL_SHIFT>
 ;---------------------------------------------------------------------
 ; Predication flags on instruction token
D3DSHADER_INSTRUCTION_PREDICATED	equ	<01h SHL  28>
 ;---------------------------------------------------------------------
 ; DCL Info Token Controls
 ; For dcl info tokens requiring a semantic (usage + index)
D3DSP_DCL_USAGE_SHIFT	equ	<0>
D3DSP_DCL_USAGE_MASK	equ	<00000000fh>
D3DSP_DCL_USAGEINDEX_SHIFT	equ	<16>
D3DSP_DCL_USAGEINDEX_MASK	equ	<0000f0000h>
 ; DCL pixel shader sampler info token.
D3DSP_TEXTURETYPE_SHIFT	equ	<27>
D3DSP_TEXTURETYPE_MASK	equ	<078000000h>

;D3DSAMPLER_TEXTURE_TYPE	UNION
	D3DSTT_UNKNOWN	EQU <0 SHL D3DSP_TEXTURETYPE_SHIFT >	 ; uninitialized value
	D3DSTT_2D	EQU <2 SHL D3DSP_TEXTURETYPE_SHIFT >	 ; dcl_2d s# (for declaring a 2-D texture)
	D3DSTT_CUBE	EQU <3 SHL D3DSP_TEXTURETYPE_SHIFT >	 ; dcl_cube s# (for declaring a cube texture)
	D3DSTT_VOLUME	EQU <4 SHL D3DSP_TEXTURETYPE_SHIFT >	 ; dcl_volume s# (for declaring a volume texture)
	D3DSTT_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DSAMPLER_TEXTURE_TYPE		ENDS


 ;---------------------------------------------------------------------
 ; Parameter Token Bit Definitions
 ;
D3DSP_REGNUM_MASK	equ	<0000007FFh>
 ; destination parameter write mask
D3DSP_WRITEMASK_0	equ	<000010000h>
D3DSP_WRITEMASK_1	equ	<000020000h>
D3DSP_WRITEMASK_2	equ	<000040000h>
D3DSP_WRITEMASK_3	equ	<000080000h>
D3DSP_WRITEMASK_ALL	equ	<0000F0000h>
 ; destination parameter modifiers
D3DSP_DSTMOD_SHIFT	equ	<20>
D3DSP_DSTMOD_MASK	equ	<000F00000h>
 ; Bit masks for destination parameter modifiers
 ;      When the pixel center is not covered, sample
 ;      attribute or compute gradients/LOD
 ;      using multisample "centroid" location.
 ;      "Centroid" is some location within the covered
 ;      region of the pixel.
 ; destination parameter
D3DSP_DSTSHIFT_SHIFT	equ	<24>
D3DSP_DSTSHIFT_MASK	equ	<00F000000h>
 ; destination/source parameter register type
D3DSP_REGTYPE_SHIFT	equ	<28>
D3DSP_REGTYPE_SHIFT2	equ	<8>
D3DSP_REGTYPE_MASK	equ	<070000000h>
D3DSP_REGTYPE_MASK2	equ	<000001800h>

;D3DSHADER_PARAM_REGISTER_TYPE	UNION
	D3DSPR_TEMP	EQU 0 	 ; Temporary Register File
	D3DSPR_INPUT	EQU 1 	 ; Input Register File
	D3DSPR_CONST	EQU 2 	 ; Constant Register File
	D3DSPR_ADDR	EQU 3 	 ; Address Register (VS)
	D3DSPR_TEXTURE	EQU 3 	 ; Texture Register File (PS)
	D3DSPR_RASTOUT	EQU 4 	 ; Rasterizer Register File
	D3DSPR_ATTROUT	EQU 5 	 ; Attribute Output Register File
	D3DSPR_TEXCRDOUT	EQU 6 	 ; Texture Coordinate Output Register File
	D3DSPR_OUTPUT	EQU 6 	 ; Output register file for VS3.0+
	D3DSPR_CONSTINT	EQU 7 	 ; Constant Integer Vector Register File
	D3DSPR_COLOROUT	EQU 8 	 ; Color Output Register File
	D3DSPR_DEPTHOUT	EQU 9 	 ; Depth Output Register File
	D3DSPR_SAMPLER	EQU 10 	 ; Sampler State Register File
	D3DSPR_CONST2	EQU 11 	 ; Constant Register File  2048 - 4095
	D3DSPR_CONST3	EQU 12 	 ; Constant Register File  4096 - 6143
	D3DSPR_CONST4	EQU 13 	 ; Constant Register File  6144 - 8191
	D3DSPR_CONSTBOOL	EQU 14 	 ; Constant Boolean register file
	D3DSPR_LOOP	EQU 15 	 ; Loop counter register file
	D3DSPR_TEMPFLOAT16	EQU 16 	 ; 16-bit float temp register file
	D3DSPR_MISCTYPE	EQU 17 	 ; Miscellaneous (single) registers.
	D3DSPR_LABEL	EQU 18 	 ; Label
	D3DSPR_PREDICATE	EQU 19 	 ; Predicate register
	D3DSPR_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DSHADER_PARAM_REGISTER_TYPE		ENDS

 ; The miscellaneous register file (D3DSPR_MISCTYPES)
 ; contains register types for which there is only ever one
 ; register (i.e. the register # is not needed).
 ; Rather than use up additional register types for such
 ; registers, they are defined
 ; as particular offsets into the misc. register file:

;D3DSHADER_MISCTYPE_OFFSETS	UNION
	D3DSMO_POSITION	EQU 0 	 ; Input position x,y,z,rhw (PS)
	D3DSMO_FACE	EQU 1 	 ; Floating point primitive area (PS)
;D3DSHADER_MISCTYPE_OFFSETS		ENDS


 ; Register offsets in the Rasterizer Register File
 ;

;D3DVS_RASTOUT_OFFSETS	UNION
	D3DSRO_POSITION	EQU 0 
	D3DSRO_FOG	EQU 01H
	D3DSRO_POINT_SIZE	EQU 02H
	D3DSRO_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DVS_RASTOUT_OFFSETS		ENDS


 ; Source operand addressing modes
D3DVS_ADDRESSMODE_SHIFT	equ	<13>
D3DVS_ADDRESSMODE_MASK	equ	<1 SHL  D3DVS_ADDRESSMODE_SHIFT>

;D3DVS_ADDRESSMODE_TYPE	UNION
	D3DVS_ADDRMODE_ABSOLUTE	EQU <0 	SHL \
D3DVS_ADDRESSMODE_SHIFT >
	D3DVS_ADDRMODE_RELATIVE	EQU <1 	SHL \
D3DVS_ADDRESSMODE_SHIFT >
	D3DVS_ADDRMODE_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DVS_ADDRESSMODE_TYPE		ENDS


D3DSHADER_ADDRESSMODE_SHIFT	equ	<13>
D3DSHADER_ADDRESSMODE_MASK	equ	<1 SHL  D3DSHADER_ADDRESSMODE_SHIFT>

;D3DSHADER_ADDRESSMODE_TYPE	UNION
	D3DSHADER_ADDRMODE_ABSOLUTE	EQU <0 	SHL \
D3DSHADER_ADDRESSMODE_SHIFT >
	D3DSHADER_ADDRMODE_RELATIVE	EQU <1 	SHL \
D3DSHADER_ADDRESSMODE_SHIFT >
	D3DSHADER_ADDRMODE_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DSHADER_ADDRESSMODE_TYPE		ENDS


 ; Source operand swizzle definitions
 ;
D3DVS_SWIZZLE_SHIFT	equ	<16>
D3DVS_SWIZZLE_MASK	equ	<000FF0000h>
 ; The following bits define where to take component X from:
D3DVS_X_X	equ	<0 SHL  D3DVS_SWIZZLE_SHIFT>
D3DVS_X_Y	equ	<1 SHL  D3DVS_SWIZZLE_SHIFT>
D3DVS_X_Z	equ	<2 SHL  D3DVS_SWIZZLE_SHIFT>
D3DVS_X_W	equ	<3 SHL  D3DVS_SWIZZLE_SHIFT>
 ; The following bits define where to take component Y from:
D3DVS_Y_X	equ	<0 SHL >
D3DVS_Y_Y	equ	<1 SHL >
D3DVS_Y_Z	equ	<2 SHL >
D3DVS_Y_W	equ	<3 SHL >
 ; The following bits define where to take component Z from:
D3DVS_Z_X	equ	<0 SHL >
D3DVS_Z_Y	equ	<1 SHL >
D3DVS_Z_Z	equ	<2 SHL >
D3DVS_Z_W	equ	<3 SHL >
 ; The following bits define where to take component W from:
D3DVS_W_X	equ	<0 SHL >
D3DVS_W_Y	equ	<1 SHL >
D3DVS_W_Z	equ	<2 SHL >
D3DVS_W_W	equ	<3 SHL >
 ; Value when there is no swizzle (X is taken from X, Y is taken from Y,
 ; Z is taken from Z, W is taken from W
 ;
D3DVS_NOSWIZZLE	equ	<D3DVS_X_X OR  D3DVS_Y_Y OR  D3DVS_Z_Z OR  D3DVS_W_W>
 ; source parameter swizzle
D3DSP_SWIZZLE_SHIFT	equ	<16>
D3DSP_SWIZZLE_MASK	equ	<000FF0000h>
D3DSP_NOSWIZZLE	equ	<( 0 SHL  )  OR (  1 SHL  )  OR (  2 SHL  )  OR (  3 SHL  )>
 ; pixel-shader swizzle ops
D3DSP_REPLICATERED	equ	<( 0 SHL  )  OR (  0 SHL  )  OR (  0 SHL  )  OR (  0 SHL  )>
D3DSP_REPLICATEGREEN	equ	<( 1 SHL  )  OR (  1 SHL  )  OR (  1 SHL  )  OR (  1 SHL  )>
D3DSP_REPLICATEBLUE	equ	<( 2 SHL  )  OR (  2 SHL  )  OR (  2 SHL  )  OR (  2 SHL  )>
D3DSP_REPLICATEALPHA	equ	<( 3 SHL  )  OR (  3 SHL  )  OR (  3 SHL  )  OR (  3 SHL  )>
 ; source parameter modifiers
D3DSP_SRCMOD_SHIFT	equ	<24>
D3DSP_SRCMOD_MASK	equ	<00F000000h>

;D3DSHADER_PARAM_SRCMOD_TYPE	UNION
	D3DSPSM_NONE	EQU <0 SHL D3DSP_SRCMOD_SHIFT >	 ; nop
	D3DSPSM_NEG	EQU <1 SHL D3DSP_SRCMOD_SHIFT >	 ; negate
	D3DSPSM_BIAS	EQU <2 SHL D3DSP_SRCMOD_SHIFT >	 ; bias
	D3DSPSM_BIASNEG	EQU <3 SHL D3DSP_SRCMOD_SHIFT >	 ; bias and negate
	D3DSPSM_SIGN	EQU <4 SHL D3DSP_SRCMOD_SHIFT >	 ; sign
	D3DSPSM_SIGNNEG	EQU <5 SHL D3DSP_SRCMOD_SHIFT >	 ; sign and negate
	D3DSPSM_COMP	EQU <6 SHL D3DSP_SRCMOD_SHIFT >	 ; complement
	D3DSPSM_X2	EQU <7 SHL D3DSP_SRCMOD_SHIFT >	 ; *2
	D3DSPSM_X2NEG	EQU <8 SHL D3DSP_SRCMOD_SHIFT >	 ; *2 and negate
	D3DSPSM_DZ	EQU <9 SHL D3DSP_SRCMOD_SHIFT >	 ; divide through by z component
	D3DSPSM_DW	EQU <10 SHL D3DSP_SRCMOD_SHIFT >	 ; divide through by w component
	D3DSPSM_ABS	EQU <11 SHL D3DSP_SRCMOD_SHIFT >	 ; abs()
	D3DSPSM_ABSNEG	EQU <12 SHL D3DSP_SRCMOD_SHIFT >	 ; -abs()
	D3DSPSM_NOT	EQU <13 SHL D3DSP_SRCMOD_SHIFT >	 ; for predicate register: "!p0"
	D3DSPSM_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DSHADER_PARAM_SRCMOD_TYPE		ENDS

 ; pixel shader version token
 ; vertex shader version token
 ; extract major/minor from version cap
 ; destination/source parameter register type
D3DSI_COMMENTSIZE_SHIFT	equ	<16>
D3DSI_COMMENTSIZE_MASK	equ	<07FFF0000h>
 ; pixel/vertex shader end token
 ;---------------------------------------------------------------------
 ; High order surfaces
 ;

;D3DBASISTYPE	UNION
	D3DBASIS_BEZIER	EQU 0 
	D3DBASIS_BSPLINE	EQU 1 
	D3DBASIS_CATMULL_ROM	EQU 2 	 ; In D3D8 this used to be D3DBASIS_INTERPOLATE 
	D3DBASIS_FORCE_DWORD	EQU 07fffffffh 
;D3DBASISTYPE		ENDS



;D3DDEGREETYPE	UNION
	D3DDEGREE_LINEAR	EQU 1 
	D3DDEGREE_QUADRATIC	EQU 2 
	D3DDEGREE_CUBIC	EQU 3 
	D3DDEGREE_QUINTIC	EQU 5 
	D3DDEGREE_FORCE_DWORD	EQU 07fffffffh 
;D3DDEGREETYPE		ENDS



;D3DPATCHEDGESTYLE	UNION
	D3DPATCHEDGE_DISCRETE	EQU 0 
	D3DPATCHEDGE_CONTINUOUS	EQU 1 
	D3DPATCHEDGE_FORCE_DWORD	EQU 07fffffffh 
;D3DPATCHEDGESTYLE		ENDS



;D3DSTATEBLOCKTYPE	UNION
	D3DSBT_ALL	EQU 1 	 ; capture all state
	D3DSBT_PIXELSTATE	EQU 2 	 ; capture pixel state
	D3DSBT_VERTEXSTATE	EQU 3 	 ; capture vertex state
	D3DSBT_FORCE_DWORD	EQU 07fffffffh 
;D3DSTATEBLOCKTYPE		ENDS


 ; The D3DVERTEXBLENDFLAGS type is used with D3DRS_VERTEXBLEND state.
 ;

;D3DVERTEXBLENDFLAGS	UNION
	D3DVBF_DISABLE	EQU 0 	 ; Disable vertex blending
	D3DVBF_1WEIGHTS	EQU 1 	 ; 2 matrix blending
	D3DVBF_2WEIGHTS	EQU 2 	 ; 3 matrix blending
	D3DVBF_3WEIGHTS	EQU 3 	 ; 4 matrix blending
	D3DVBF_TWEENING	EQU 255 	 ; blending using D3DRS_TWEENFACTOR
	D3DVBF_0WEIGHTS	EQU 256 	 ; one matrix is used with weight 1.0
	D3DVBF_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum
;D3DVERTEXBLENDFLAGS		ENDS



;D3DTEXTURETRANSFORMFLAGS	UNION
	D3DTTFF_DISABLE	EQU 0 	 ; texture coordinates are passed directly
	D3DTTFF_COUNT1	EQU 1 	 ; rasterizer should expect 1-D texture coords
	D3DTTFF_COUNT2	EQU 2 	 ; rasterizer should expect 2-D texture coords
	D3DTTFF_COUNT3	EQU 3 	 ; rasterizer should expect 3-D texture coords
	D3DTTFF_COUNT4	EQU 4 	 ; rasterizer should expect 4-D texture coords
	D3DTTFF_PROJECTED	EQU 256 	 ; texcoords to be divided by COUNTth element
	D3DTTFF_FORCE_DWORD	EQU 07fffffffh 
;D3DTEXTURETRANSFORMFLAGS		ENDS

 ; Macros to set texture coordinate format bits in the FVF id
D3DFVF_TEXTUREFORMAT2	equ	<0>
D3DFVF_TEXTUREFORMAT1	equ	<3>
D3DFVF_TEXTUREFORMAT3	equ	<1>
D3DFVF_TEXTUREFORMAT4	equ	<2>
 ;---------------------------------------------------------------------
 ; Direct3D9 Device types 

;D3DDEVTYPE	UNION
	D3DDEVTYPE_HAL	EQU 1 
	D3DDEVTYPE_REF	EQU 2 
	D3DDEVTYPE_SW	EQU 3 
	D3DDEVTYPE_FORCE_DWORD	EQU 07fffffffh 
;D3DDEVTYPE		ENDS


 ; Multi-Sample buffer types 

;D3DMULTISAMPLE_TYPE	UNION
	D3DMULTISAMPLE_NONE	EQU 0 
	D3DMULTISAMPLE_NONMASKABLE	EQU 1 
	D3DMULTISAMPLE_2_SAMPLES	EQU 2 
	D3DMULTISAMPLE_3_SAMPLES	EQU 3 
	D3DMULTISAMPLE_4_SAMPLES	EQU 4 
	D3DMULTISAMPLE_5_SAMPLES	EQU 5 
	D3DMULTISAMPLE_6_SAMPLES	EQU 6 
	D3DMULTISAMPLE_7_SAMPLES	EQU 7 
	D3DMULTISAMPLE_8_SAMPLES	EQU 8 
	D3DMULTISAMPLE_9_SAMPLES	EQU 9 
	D3DMULTISAMPLE_10_SAMPLES	EQU 10 
	D3DMULTISAMPLE_11_SAMPLES	EQU 11 
	D3DMULTISAMPLE_12_SAMPLES	EQU 12 
	D3DMULTISAMPLE_13_SAMPLES	EQU 13 
	D3DMULTISAMPLE_14_SAMPLES	EQU 14 
	D3DMULTISAMPLE_15_SAMPLES	EQU 15 
	D3DMULTISAMPLE_16_SAMPLES	EQU 16 
	D3DMULTISAMPLE_FORCE_DWORD	EQU 07fffffffh 
;D3DMULTISAMPLE_TYPE		ENDS

 ; Formats
;* Most of these names have the following convention:
;*      A = Alpha
;*      R = Red
;*      G = Green
;*      B = Blue
;*      X = Unused Bits
;*      P = Palette
;*      L = Luminance
;*      U = dU coordinate for BumpMap
;*      V = dV coordinate for BumpMap
;*      S = Stencil
;*      D = Depth (e.g. Z or W buffer)
;*      C = Computed from other channels (typically on certain read operations)
;*      Further, the order of the pieces are from MSB first; hence
;*      D3DFMT_A8L8 indicates that the high byte of this two byte
;*      format is alpha.
;*      D16 indicates:
;*           - An integer 16-bit value.
;*           - An app-lockable surface.
;*      All Depth/Stencil formats except D3DFMT_D16_LOCKABLE indicate:
;*          - no particular bit ordering per pixel, and
;*          - are not app lockable, and
;*          - the driver is allowed to consume more than the indicated
;*            number of bits per Depth channel (but not Stencil channel).
;*/
IFNDEF MAKEFOURCC
ENDIF  ; defined(MAKEFOURCC) 

    D3DFMT_UNKNOWN              EQU   0
    D3DFMT_R8G8B8               EQU  20
    D3DFMT_A8R8G8B8             EQU  21
    D3DFMT_X8R8G8B8             EQU  22
    D3DFMT_R5G6B5               EQU  23
    D3DFMT_X1R5G5B5             EQU  24
    D3DFMT_A1R5G5B5             EQU  25
    D3DFMT_A4R4G4B4             EQU  26
    D3DFMT_R3G3B2               EQU  27
    D3DFMT_A8                   EQU  28
    D3DFMT_A8R3G3B2             EQU  29
    D3DFMT_X4R4G4B4             EQU  30
    D3DFMT_A2B10G10R10          EQU  31
    D3DFMT_A8B8G8R8             EQU  32
    D3DFMT_X8B8G8R8             EQU  33
    D3DFMT_G16R16               EQU  34
    D3DFMT_A2R10G10B10          EQU  35
    D3DFMT_A16B16G16R16         EQU  36

    D3DFMT_A8P8                 EQU  40
    D3DFMT_P8                   EQU  41

    D3DFMT_L8                   EQU  50
    D3DFMT_A8L8                 EQU  51
    D3DFMT_A4L4                 EQU  52

    D3DFMT_V8U8                 EQU  60
    D3DFMT_L6V5U5               EQU  61
    D3DFMT_X8L8V8U8             EQU  62
    D3DFMT_Q8W8V8U8             EQU  63
    D3DFMT_V16U16               EQU  64
    D3DFMT_A2W10V10U10          EQU  67

    ;D3DFMT_UYVY                 = MAKEFOURCC('U', 'Y', 'V', 'Y'),
    ;D3DFMT_R8G8_B8G8            = MAKEFOURCC('R', 'G', 'B', 'G'),
    ;D3DFMT_YUY2                 = MAKEFOURCC('Y', 'U', 'Y', '2'),
    ;D3DFMT_G8R8_G8B8            = MAKEFOURCC('G', 'R', 'G', 'B'),
    ;D3DFMT_DXT1                 = MAKEFOURCC('D', 'X', 'T', '1'),
    ;D3DFMT_DXT2                 = MAKEFOURCC('D', 'X', 'T', '2'),
    ;D3DFMT_DXT3                 = MAKEFOURCC('D', 'X', 'T', '3'),
    ;D3DFMT_DXT4                 = MAKEFOURCC('D', 'X', 'T', '4'),
    ;D3DFMT_DXT5                 = MAKEFOURCC('D', 'X', 'T', '5'),

    D3DFMT_D16_LOCKABLE         EQU  70
    D3DFMT_D32                  EQU  71
    D3DFMT_D15S1                EQU  73
    D3DFMT_D24S8                EQU  75
    D3DFMT_D24X8                EQU  77
    D3DFMT_D24X4S4              EQU  79
    D3DFMT_D16                  EQU  80

    D3DFMT_D32F_LOCKABLE        EQU  82
    D3DFMT_D24FS8               EQU  83


    D3DFMT_L16                  EQU  81

    D3DFMT_VERTEXDATA           EQU 100
    D3DFMT_INDEX16              EQU 101
    D3DFMT_INDEX32              EQU 102

    D3DFMT_Q16W16V16U16         EQU 110

    ;D3DFMT_MULTI2_ARGB8         = MAKEFOURCC('M','E','T','1'),

    ;Floating point surface formats

    ;s10e5 formats (16-bits per channel)
    D3DFMT_R16F                 EQU  111
    D3DFMT_G16R16F              EQU  112
    D3DFMT_A16B16G16R16F        EQU  113

    ;IEEE s23e8 formats (32-bits per channel)
    D3DFMT_R32F                 EQU  114
    D3DFMT_G32R32F              EQU  115
    D3DFMT_A32B32G32R32F        EQU  116

    D3DFMT_CxV8U8               EQU  117


    D3DFMT_FORCE_DWORD          EQU 0x7fffffff


 ; Display Modes 

D3DDISPLAYMODE	STRUCT
	Width1 DWORD ?
	Height DWORD ?
	RefreshRate DWORD ?
	Format DWORD ?

D3DDISPLAYMODE		ENDS

 ; Creation Parameters 

D3DDEVICE_CREATION_PARAMETERS	STRUCT
	AdapterOrdinal DWORD ?
	DeviceType DWORD ?
	hFocusWindow DWORD ?
	BehaviorFlags DWORD ?

D3DDEVICE_CREATION_PARAMETERS		ENDS

 ; SwapEffects 

;D3DSWAPEFFECT	UNION
	D3DSWAPEFFECT_DISCARD	EQU 1 
	D3DSWAPEFFECT_FLIP	EQU 2 
	D3DSWAPEFFECT_COPY	EQU 3 
	D3DSWAPEFFECT_FORCE_DWORD	EQU 07fffffffh 
;D3DSWAPEFFECT		ENDS


 ; Pool types 

;D3DPOOL	UNION
	D3DPOOL_DEFAULT	EQU 0 
	D3DPOOL_MANAGED	EQU 1 
	D3DPOOL_SYSTEMMEM	EQU 2 
	D3DPOOL_SCRATCH	EQU 3 
	D3DPOOL_FORCE_DWORD	EQU 07fffffffh 
;D3DPOOL		ENDS


 ; RefreshRate pre-defines 
D3DPRESENT_RATE_DEFAULT	equ	<000000000h>
 ; Resize Optional Parameters 

D3DPRESENT_PARAMETERS	STRUCT
	BackBufferWidth DWORD ?
	BackBufferHeight DWORD ?
	BackBufferFormat DWORD ?
	BackBufferCount DWORD ?
	MultiSampleType DWORD ?
	MultiSampleQuality DWORD ?
	SwapEffect DWORD ?
	hDeviceWindow DWORD ?
	Windowed DWORD ?
	EnableAutoDepthStencil DWORD ?
	AutoDepthStencilFormat DWORD ?
	Flags DWORD ?
	FullScreen_RefreshRateInHz DWORD ?
	PresentationInterval DWORD ?

D3DPRESENT_PARAMETERS		ENDS

 ; Values for D3DPRESENT_PARAMETERS.Flags
D3DPRESENTFLAG_LOCKABLE_BACKBUFFER	equ	<000000001h>
D3DPRESENTFLAG_DISCARD_DEPTHSTENCIL	equ	<000000002h>
D3DPRESENTFLAG_DEVICECLIP	equ	<000000004h>
D3DPRESENTFLAG_VIDEO	equ	<000000010h>
 ; Gamma Ramp: Same as DX7 

D3DGAMMARAMP	STRUCT
	red WORD 256 dup (?)
	green WORD 256 dup (?)
	blue WORD 256 dup (?)

D3DGAMMARAMP		ENDS

 ; Back buffer types 

;D3DBACKBUFFER_TYPE	UNION
	D3DBACKBUFFER_TYPE_MONO	EQU 0 
	D3DBACKBUFFER_TYPE_LEFT	EQU 1 
	D3DBACKBUFFER_TYPE_RIGHT	EQU 2 
	D3DBACKBUFFER_TYPE_FORCE_DWORD	EQU 07fffffffh 
;D3DBACKBUFFER_TYPE		ENDS


 ; Types 

;D3DRESOURCETYPE	UNION
	D3DRTYPE_SURFACE	EQU 1 
	D3DRTYPE_VOLUME	EQU 2 
	D3DRTYPE_TEXTURE	EQU 3 
	D3DRTYPE_VOLUMETEXTURE	EQU 4 
	D3DRTYPE_CUBETEXTURE	EQU 5 
	D3DRTYPE_VERTEXBUFFER	EQU 6 
	D3DRTYPE_INDEXBUFFER	EQU 7 
	D3DRTYPE_FORCE_DWORD	EQU 07fffffffh 
;D3DRESOURCETYPE		ENDS


 ; Usages 
D3DUSAGE_RENDERTARGET	equ	<000000001h>
D3DUSAGE_DEPTHSTENCIL	equ	<000000002h>
D3DUSAGE_DYNAMIC	equ	<000000200h>
 ; When passed to CheckDeviceFormat, D3DUSAGE_AUTOGENMIPMAP may return
 ; D3DOK_NOAUTOGEN if the device doesn't support autogeneration for that format.
 ; D3DOK_NOAUTOGEN is a success code, not a failure code... the SUCCEEDED and FAILED macros
 ; will return true and false respectively for this code.
D3DUSAGE_AUTOGENMIPMAP	equ	<000000400h>
D3DUSAGE_DMAP	equ	<000004000h>
 ; The following usages are valid only for querying CheckDeviceFormat
D3DUSAGE_QUERY_LEGACYBUMPMAP	equ	<000008000h>
D3DUSAGE_QUERY_SRGBREAD	equ	<000010000h>
D3DUSAGE_QUERY_FILTER	equ	<000020000h>
D3DUSAGE_QUERY_SRGBWRITE	equ	<000040000h>
D3DUSAGE_QUERY_POSTPIXELSHADER_BLENDING	equ	<000080000h>
D3DUSAGE_QUERY_VERTEXTEXTURE	equ	<000100000h>
 ; Usages for Vertex/Index buffers 
D3DUSAGE_WRITEONLY	equ	<000000008h>
D3DUSAGE_SOFTWAREPROCESSING	equ	<000000010h>
D3DUSAGE_DONOTCLIP	equ	<000000020h>
D3DUSAGE_POINTS	equ	<000000040h>
D3DUSAGE_RTPATCHES	equ	<000000080h>
D3DUSAGE_NPATCHES	equ	<000000100h>
 ; CubeMap Face identifiers 

;D3DCUBEMAP_FACES	UNION
	D3DCUBEMAP_FACE_POSITIVE_X	EQU 0 
	D3DCUBEMAP_FACE_NEGATIVE_X	EQU 1 
	D3DCUBEMAP_FACE_POSITIVE_Y	EQU 2 
	D3DCUBEMAP_FACE_NEGATIVE_Y	EQU 3 
	D3DCUBEMAP_FACE_POSITIVE_Z	EQU 4 
	D3DCUBEMAP_FACE_NEGATIVE_Z	EQU 5 
	D3DCUBEMAP_FACE_FORCE_DWORD	EQU 07fffffffh 
;D3DCUBEMAP_FACES		ENDS


 ; Lock flags 
D3DLOCK_READONLY	equ	<000000010h>
D3DLOCK_DISCARD	equ	<000002000h>
D3DLOCK_NOOVERWRITE	equ	<000001000h>
D3DLOCK_NOSYSLOCK	equ	<000000800h>
D3DLOCK_DONOTWAIT	equ	<000004000h>
D3DLOCK_NO_DIRTY_UPDATE	equ	<000008000h>
 ; Vertex Buffer Description 

D3DVERTEXBUFFER_DESC	STRUCT
	Format DWORD ?
	type1 DWORD ?
	Usage DWORD ?
	Pool DWORD ?
	size1 DWORD ?
	FVF DWORD ?

D3DVERTEXBUFFER_DESC		ENDS

 ; Index Buffer Description 

D3DINDEXBUFFER_DESC	STRUCT
	Format DWORD ?
	type1 DWORD ?
	Usage DWORD ?
	Pool DWORD ?
	size1 DWORD ?

D3DINDEXBUFFER_DESC		ENDS

 ; Surface Description 

D3DSURFACE_DESC	STRUCT
	Format DWORD ?
	type1 DWORD ?
	Usage DWORD ?
	Pool DWORD ?
	MultiSampleType DWORD ?
	MultiSampleQuality DWORD ?
	Width1 DWORD ?
	Height DWORD ?

D3DSURFACE_DESC		ENDS


D3DVOLUME_DESC	STRUCT
	Format DWORD ?
	type1 DWORD ?
	Usage DWORD ?
	Pool DWORD ?
	Width1 DWORD ?
	Height DWORD ?
	Depth DWORD ?

D3DVOLUME_DESC		ENDS

 ; Structure for LockRect 

D3DLOCKED_RECT	STRUCT
	Pitch DWORD ?
	pBits DWORD ?

D3DLOCKED_RECT		ENDS

 ; Structures for LockBox 

D3DBOX	STRUCT
	Left DWORD ?
	Top DWORD ?
	Right DWORD ?
	Bottom DWORD ?
	Front DWORD ?
	Back DWORD ?

D3DBOX		ENDS


D3DLOCKED_BOX	STRUCT
	RowPitch DWORD ?
	SlicePitch DWORD ?
	pBits DWORD ?

D3DLOCKED_BOX		ENDS

 ; Structures for LockRange 

D3DRANGE	STRUCT
	offset1 DWORD ?
	size1 DWORD ?

D3DRANGE		ENDS

 ; Structures for high order primitives 

D3DRECTPATCH_INFO	STRUCT
	StartVertexOffsetWidth DWORD ?
	StartVertexOffsetHeight DWORD ?
	Width1 DWORD ?
	Height DWORD ?
	Stride DWORD ?
	Basis DWORD ?
	Degree DWORD ?

D3DRECTPATCH_INFO		ENDS


D3DTRIPATCH_INFO	STRUCT
	StartVertexOffset DWORD ?
	NumVertices DWORD ?
	Basis DWORD ?
	Degree DWORD ?

D3DTRIPATCH_INFO		ENDS

 ; Adapter Identifier 
MAX_DEVICE_IDENTIFIER_STRING	equ	<512>

D3DADAPTER_IDENTIFIER9	STRUCT
	Driver BYTE MAX_DEVICE_IDENTIFIER_STRING dup (?)
	Description BYTE MAX_DEVICE_IDENTIFIER_STRING dup (?)
	DeviceName BYTE 32 dup (?)  ; Device name for GDI (ex. \\.\DISPLAY1) 
IFDEF _WIN32
	DriverVersion LARGE_INTEGER <>   ; Defined for 32 bit components 
	ELSE
	DriverVersionLowPart DWORD ?  ; Defined for 16 bit driver components 
	DriverVersionHighPart DWORD ?
ENDIF 
	VendorId DWORD ?
	DeviceId DWORD ?
	SubSysId DWORD ?
	Revision DWORD ?
	DeviceIdentifier GUID <> 
	WHQLLevel DWORD ?

D3DADAPTER_IDENTIFIER9		ENDS

 ; Raster Status structure returned by GetRasterStatus 

D3DRASTER_STATUS	STRUCT
	InVBlank DWORD ?
	ScanLine DWORD ?

D3DRASTER_STATUS		ENDS

 ; Debug monitor tokens (DEBUG only)
;Note that if D3DRS_DEBUGMONITORTOKEN is set, the call is treated as
;passing a token to the debug monitor.  For example, if, after passing
;D3DDMT_ENABLE/DISABLE to D3DRS_DEBUGMONITORTOKEN other token values
;are passed in, the enabled/disabled state of the debug
;monitor will still persist.
;The debug monitor defaults to enabled.
;Calling GetRenderState on D3DRS_DEBUGMONITORTOKEN is not of any use.
;*/

;D3DDEBUGMONITORTOKENS	UNION
	D3DDMT_ENABLE	EQU 0 	 ; enable debug monitor
	D3DDMT_DISABLE	EQU 1 	 ; disable debug monitor
	D3DDMT_FORCE_DWORD	EQU 07fffffffh 
;D3DDEBUGMONITORTOKENS		ENDS


 ; Async feedback

;D3DQUERYTYPE	UNION
	D3DQUERYTYPE_VCACHE	EQU 4 	 ; D3DISSUE_END 
	D3DQUERYTYPE_RESOURCEMANAGER	EQU 5 	 ; D3DISSUE_END 
	D3DQUERYTYPE_VERTEXSTATS	EQU 6 	 ; D3DISSUE_END 
	D3DQUERYTYPE_EVENT	EQU 8 	 ; D3DISSUE_END 
	D3DQUERYTYPE_OCCLUSION	EQU 9 	 ; D3DISSUE_BEGIN, D3DISSUE_END 
;D3DQUERYTYPE		ENDS


 ; Flags field for Issue
D3DISSUE_END	equ	<1 SHL  0>
D3DISSUE_BEGIN	equ	<1 SHL  1>
 ; Flags field for GetData
D3DGETDATA_FLUSH	equ	<1 SHL  0>

D3DRESOURCESTATS	STRUCT
	bThrashing DWORD ?  ; indicates if thrashing 
	ApproxBytesDownloaded DWORD ?  ; Approximate number of bytes downloaded by resource manager 
	NumEvicts DWORD ?  ; number of objects evicted 
	NumVidCreates DWORD ?  ; number of objects created in video memory 
	LastPri DWORD ?  ; priority of last object evicted 
	NumUsed DWORD ?  ; number of objects set to the device 
	NumUsedInVidMem DWORD ?  ; number of objects set to the device, which are already in video memory 
	WorkingSet DWORD ?  ; number of objects in video memory 
	WorkingSetBytes DWORD ?  ; number of bytes in video memory 
	TotalManaged DWORD ?  ; total number of managed objects 
	TotalBytes DWORD ?  ; total number of bytes of managed objects 

D3DRESOURCESTATS		ENDS

D3DRTYPECOUNT	equ	<D3DRTYPE_INDEXBUFFER +  1>

D3DDEVINFO_RESOURCEMANAGER	STRUCT
	stats D3DRESOURCESTATS D3DRTYPECOUNT dup (<>)

D3DDEVINFO_RESOURCEMANAGER		ENDS


D3DDEVINFO_D3DVERTEXSTATS	STRUCT
	NumRenderedTriangles DWORD ?  ; total number of triangles that are not clipped in this frame 
	NumExtraClippingTriangles DWORD ?  ; Number of new triangles generated by clipping 

D3DDEVINFO_D3DVERTEXSTATS		ENDS


D3DDEVINFO_VCACHE	STRUCT
	Pattern DWORD ?  ; bit pattern, return value must be FOUR_CC(C, A, C, H) 
	OptMethod DWORD ?  ; optimization method 0 means longest strips, 1 means vertex cache based 
	CacheSize DWORD ?  ; cache size to optimize for  (only required if type is 1) 
	MagicNumber DWORD ?  ; used to determine when to restart strips (only required if type is 1)

D3DDEVINFO_VCACHE		ENDS

;ECHO   pack()
IF COMPARE (_MSC_VER,GE,1200)
;ECHO   warning(pop)
ELSE
;ECHO   warning(default:4201)
ENDIF 
ENDIF  ; (DIRECT3D_VERSION >= 0x0900) 
ENDIF  ; _d3d9TYPES(P)_H_ 
