 ;////////////////////////////////////////////////////////////////////////////
 ;
 ;  Copyright (C) Microsoft Corporation.  All Rights Reserved.
 ;
 ;  File:       d3dx9mesh.h
 ;  Content:    D3DX mesh types and functions
 ;
 ;////////////////////////////////////////////////////////////////////////////
IFNDEF __D3DX9_H__
INCLUDE d3dx9.INC
ENDIF

IFNDEF __D3DX9MESH_H__
__D3DX9MESH_H__ equ

Include dxfile.inc ; defines LPDIRECTXFILEDATA
 ; {2A835771-BF4D-43f4-8E14-82A809F17D8A}
sIID_ID3DXBaseMesh	TEXTEQU	<{02a835771h,0bf4dh,043f4h,(08eh,014h,082h,0a8h,09h,0f1h,07dh,08ah}}>
 ; {CCAE5C3B-4DD1-4d0f-997E-4684CA64557F}
sIID_ID3DXMesh	TEXTEQU	<{0ccae5c3bh,04dd1h,04d0fh,(099h,07eh,046h,084h,0cah,064h,055h,07fh}}>
 ; {19FBE386-C282-4659-97BD-CB869B084A6C}
sIID_ID3DXPMesh	TEXTEQU	<{019fbe386h,0c282h,04659h,(097h,0bdh,0cbh,086h,09bh,08h,04ah,06ch}}>
 ; {4E3CA05C-D4FF-4d11-8A02-16459E08F6F4}
sIID_ID3DXSPMesh	TEXTEQU	<{04e3ca05ch,0d4ffh,04d11h,(08ah,02h,016h,045h,09eh,08h,0f6h,0f4h}}>
 ; {0E7DBBF3-421A-4dd8-B738-A5DAC3A48767}
sIID_ID3DXSkinInfo	TEXTEQU	<{0e7dbbf3h,0421ah,04dd8h,(0b7h,038h,0a5h,0dah,0c3h,0a4h,087h,067h}}>
 ; {0AD3E8BC-290D-4dc7-91AB-73A82755B13E}
sIID_ID3DXPatchMesh	TEXTEQU	<{0ad3e8bch,0290dh,04dc7h,(091h,0abh,073h,0a8h,027h,055h,0b1h,03eh}}>
 ;patch mesh can be quads or tris

;D3DXPATCHMESHTYPE	UNION
	D3DXPATCHMESH_RECT	EQU 0001h 
	D3DXPATCHMESH_TRI	EQU 0002h 
	D3DXPATCHMESH_NPATCH	EQU 0003h 
	D3DXPATCHMESH_FORCE_DWORD	EQU 07fffffffh 	 ; force 32-bit size enum 
;D3DXPATCHMESHTYPE		ENDS


 ; Mesh options - lower 3 bytes only, upper byte used by _D3DXMESHOPT option flags

;_D3DXMESH	UNION
	D3DXMESH_32BIT	EQU 0001h 	 ; If set, then use 32 bit indices, if not set use 16 bit indices.
	D3DXMESH_DONOTCLIP	EQU 0002h 	 ; Use D3DUSAGE_DONOTCLIP for VB & IB.
	D3DXMESH_POINTS	EQU 0004h 	 ; Use D3DUSAGE_POINTS for VB & IB. 
	D3DXMESH_RTPATCHES	EQU 0008h 	 ; Use D3DUSAGE_RTPATCHES for VB & IB. 
	D3DXMESH_NPATCHES	EQU 04000h 	 ; Use D3DUSAGE_NPATCHES for VB & IB. 
	D3DXMESH_VB_SYSTEMMEM	EQU 0010h 	 ; Use D3DPOOL_SYSTEMMEM for VB. Overrides D3DXMESH_MANAGEDVERTEXBUFFER
	D3DXMESH_VB_MANAGED	EQU 0020h 	 ; Use D3DPOOL_MANAGED for VB. 
	D3DXMESH_VB_WRITEONLY	EQU 0040h 	 ; Use D3DUSAGE_WRITEONLY for VB.
	D3DXMESH_VB_DYNAMIC	EQU 0080h 	 ; Use D3DUSAGE_DYNAMIC for VB.
	D3DXMESH_VB_SOFTWAREPROCESSING	EQU 08000h 	 ; Use D3DUSAGE_SOFTWAREPROCESSING for VB.
	D3DXMESH_IB_SYSTEMMEM	EQU 0100h 	 ; Use D3DPOOL_SYSTEMMEM for IB. Overrides D3DXMESH_MANAGEDINDEXBUFFER
	D3DXMESH_IB_MANAGED	EQU 0200h 	 ; Use D3DPOOL_MANAGED for IB.
	D3DXMESH_IB_WRITEONLY	EQU 0400h 	 ; Use D3DUSAGE_WRITEONLY for IB.
	D3DXMESH_IB_DYNAMIC	EQU 0800h 	 ; Use D3DUSAGE_DYNAMIC for IB.
	D3DXMESH_IB_SOFTWAREPROCESSING	EQU 010000h 	 ; Use D3DUSAGE_SOFTWAREPROCESSING for IB.
	D3DXMESH_VB_SHARE	EQU 01000h 	 ; Valid for Clone* calls only, forces cloned mesh/pmesh to share vertex buffer
	D3DXMESH_USEHWONLY	EQU 02000h 	 ; Valid for ID3DXSkinMesh::ConvertToBlendedMesh
	D3DXMESH_SYSTEMMEM	EQU 0110h 	 ; D3DXMESH_VB_SYSTEMMEM | D3DXMESH_IB_SYSTEMMEM
	D3DXMESH_MANAGED	EQU 0220h 	 ; D3DXMESH_VB_MANAGED | D3DXMESH_IB_MANAGED
	D3DXMESH_WRITEONLY	EQU 0440h 	 ; D3DXMESH_VB_WRITEONLY | D3DXMESH_IB_WRITEONLY
	D3DXMESH_DYNAMIC	EQU 0880h 	 ; D3DXMESH_VB_DYNAMIC | D3DXMESH_IB_DYNAMIC
	D3DXMESH_SOFTWAREPROCESSING	EQU 018000h 	 ; D3DXMESH_VB_SOFTWAREPROCESSING | D3DXMESH_IB_SOFTWAREPROCESSING
;_D3DXMESH		ENDS

 ;patch mesh options

;_D3DXPATCHMESH	UNION
	D3DXPATCHMESH_DEFAULT	EQU 000 
;_D3DXPATCHMESH		ENDS


 ; option field values for specifying min value in D3DXGeneratePMesh and D3DXSimplifyMesh

;_D3DXMESHSIMP	UNION
	D3DXMESHSIMP_VERTEX	EQU 01h 
	D3DXMESHSIMP_FACE	EQU 02h 
;_D3DXMESHSIMP		ENDS



;_MAX_FVF_DECL_SIZE	UNION
	MAX_FVF_DECL_SIZE	EQU <MAXD3DDECLLENGTH 	+ \
1 >
;_MAX_FVF_DECL_SIZE		ENDS



D3DXATTRIBUTERANGE	STRUCT
	AttribId DWORD ?
	FaceStart DWORD ?
	FaceCount DWORD ?
	VertexStart DWORD ?
	VertexCount DWORD ?

D3DXATTRIBUTERANGE		ENDS


D3DXMATERIAL	STRUCT
	MatD3D D3DMATERIAL9 <> 
	pTextureFilename DWORD ?

D3DXMATERIAL		ENDS


;D3DXEFFECTDEFAULTTYPE	UNION
	D3DXEDT_STRING	EQU 01h 	 ; pValue points to a null terminated ASCII string 
	D3DXEDT_FLOATS	EQU 02h 	 ; pValue points to an array of floats - number of floats is NumBytes / sizeof(float)
	D3DXEDT_DWORD	EQU 03h 	 ; pValue points to a DWORD
	D3DXEDT_FORCEDWORD	EQU 07fffffffh 
;D3DXEFFECTDEFAULTTYPE		ENDS



D3DXEFFECTDEFAULT	STRUCT
	pParamName DWORD ?
	type1 DWORD ?  ; type of the data pointed to by pValue
	NumBytes DWORD ?  ; size in bytes of the data pointed to by pValue
	pValue DWORD ?  ; data for the default of the effect

D3DXEFFECTDEFAULT		ENDS


D3DXEFFECTINSTANCE	STRUCT
	pEffectFilename DWORD ?
	NumDefaults DWORD ?
	pDefaults DWORD ?

D3DXEFFECTINSTANCE		ENDS


D3DXATTRIBUTEWEIGHTS	STRUCT
	Position REAL4 ?
	Boundary REAL4 ?
	Normal REAL4 ?
	Diffuse REAL4 ?
	Specular REAL4 ?
	Texcoord REAL4 8 dup (?)
	Tangent REAL4 ?
	Binormal REAL4 ?

D3DXATTRIBUTEWEIGHTS		ENDS


;_D3DXWELDEPSILONSFLAGS	UNION
	D3DXWELDEPSILONS_WELDALL	EQU 01h 	 ; weld all vertices marked by adjacency as being overlapping
	D3DXWELDEPSILONS_WELDPARTIALMATCHES	EQU 02h 	 ; if a given vertex component is within epsilon, modify partial matched 
	D3DXWELDEPSILONS_DONOTREMOVEVERTICES	EQU 04h 	 ; instructs weld to only allow modifications to vertices and not removal
	D3DXWELDEPSILONS_DONOTSPLIT	EQU 08h 	 ; instructs weld to specify the D3DXMESHOPT_DONOTSPLIT flag when doing an Optimize(ATTR_SORT)
;_D3DXWELDEPSILONSFLAGS		ENDS


D3DXWELDEPSILONS	STRUCT
	Position REAL4 ?  ; NOTE: This does NOT replace the epsilon in GenerateAdjacency
	BlendWeights REAL4 ?
	Normal REAL4 ?
	PSize REAL4 ?
	Specular REAL4 ?
	Diffuse REAL4 ?
	Texcoord REAL4 8 dup (?)
	Tangent REAL4 ?
	Binormal REAL4 ?
	TessFactor REAL4 ?

D3DXWELDEPSILONS		ENDS

INTERFACE	equ	<ID3DXBaseMesh>
;erreur traduction
;D3DVERTEXELEMENT9 structure dans dd3d9types.inc
;ID3DXBaseMesh drive de : IUnknown
	STID3DXBaseMesh	STRUCT
		QueryInterface               	comethod3 ?
		AddRef                       	comethod1 ?
		Release                      	comethod1 ?
		DrawSubset                   	comethod2 ?
		GetNumFaces                  	comethod1 ?
		GetNumVertices               	comethod1 ?
		GetFVF                       	comethod1 ?
		GetDeclaration               	comethod2 ?
		GetNumBytesPerVertex         	comethod1 ?
		GetOptions                   	comethod1 ?
		GetDevice                    	comethod2 ?
		CloneMeshFVF                 	comethod5 ?
		CloneMesh                    	comethod5 ?
		GetVertexBuffer              	comethod2 ?
		GetIndexBuffer               	comethod2 ?
		LockVertexBuffer             	comethod3 ?
		UnlockVertexBuffer           	comethod1 ?
		LockIndexBuffer              	comethod3 ?
		UnlockIndexBuffer            	comethod1 ?
		GetAttributeTable            	comethod3 ?
		ConvertPointRepsToAdjacency  	comethod3 ?
		ConvertAdjacencyToPointReps  	comethod3 ?
		GenerateAdjacency            	comethod3 ?
		UpdateSemantics              	comethod2 ?
	STID3DXBaseMesh	ENDS
 
ID3DXBaseMesh MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STID3DXBaseMesh PTR[edx]).>,<&Function,ppvID3DXBaseMesh>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvID3DXBaseMesh
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<ID3DXMesh>
;ID3DXMesh drive de : ID3DXBaseMesh
	STID3DXMesh	STRUCT
		QueryInterface               	comethod3 ?
		AddRef                       	comethod1 ?
		Release                      	comethod1 ?
		DrawSubset                   	comethod2 ?
		GetNumFaces                  	comethod1 ?
		GetNumVertices               	comethod1 ?
		GetFVF                       	comethod1 ?
		GetDeclaration               	comethod2 ?
		GetNumBytesPerVertex         	comethod1 ?
		GetOptions                   	comethod1 ?
		GetDevice                    	comethod2 ?
		CloneMeshFVF                 	comethod5 ?
		CloneMesh                    	comethod5 ?
		GetVertexBuffer              	comethod2 ?
		GetIndexBuffer               	comethod2 ?
		LockVertexBuffer             	comethod3 ?
		UnlockVertexBuffer           	comethod1 ?
		LockIndexBuffer              	comethod3 ?
		UnlockIndexBuffer            	comethod1 ?
		GetAttributeTable            	comethod3 ?
		ConvertPointRepsToAdjacency  	comethod3 ?
		ConvertAdjacencyToPointReps  	comethod3 ?
		GenerateAdjacency            	comethod3 ?
		UpdateSemantics              	comethod2 ?
		LockAttributeBuffer          	comethod3 ?
		UnlockAttributeBuffer        	comethod1 ?
		Optimize                     	comethod7 ?
		OptimizeInplace              	comethod6 ?
		SetAttributeTable            	comethod3 ?
	STID3DXMesh	ENDS
 
ID3DXMesh MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STID3DXMesh PTR[edx]).>,<&Function,ppvID3DXMesh>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvID3DXMesh
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<ID3DXPMesh>
;ID3DXPMesh drive de : ID3DXBaseMesh
	STID3DXPMesh	STRUCT
		QueryInterface               	comethod3 ?
		AddRef                       	comethod1 ?
		Release                      	comethod1 ?
		DrawSubset                   	comethod2 ?
		GetNumFaces                  	comethod1 ?
		GetNumVertices               	comethod1 ?
		GetFVF                       	comethod1 ?
		GetDeclaration               	comethod2 ?
		GetNumBytesPerVertex         	comethod1 ?
		GetOptions                   	comethod1 ?
		GetDevice                    	comethod2 ?
		CloneMeshFVF                 	comethod5 ?
		CloneMesh                    	comethod5 ?
		GetVertexBuffer              	comethod2 ?
		GetIndexBuffer               	comethod2 ?
		LockVertexBuffer             	comethod3 ?
		UnlockVertexBuffer           	comethod1 ?
		LockIndexBuffer              	comethod3 ?
		UnlockIndexBuffer            	comethod1 ?
		GetAttributeTable            	comethod3 ?
		ConvertPointRepsToAdjacency  	comethod3 ?
		ConvertAdjacencyToPointReps  	comethod3 ?
		GenerateAdjacency            	comethod3 ?
		UpdateSemantics              	comethod2 ?
		ClonePMeshFVF                	comethod5 ?
		ClonePMesh                   	comethod5 ?
		SetNumFaces                  	comethod2 ?
		SetNumVertices               	comethod2 ?
		GetMaxFaces                  	comethod1 ?
		GetMinFaces                  	comethod1 ?
		GetMaxVertices               	comethod1 ?
		GetMinVertices               	comethod1 ?
		Save                         	comethod5 ?
		Optimize                     	comethod6 ?
		OptimizeBaseLOD              	comethod3 ?
		TrimByFaces                  	comethod5 ?
		TrimByVertices               	comethod5 ?
		GetAdjacency                 	comethod2 ?
		GenerateVertexHistory        	comethod2 ?
	STID3DXPMesh	ENDS
 
ID3DXPMesh MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STID3DXPMesh PTR[edx]).>,<&Function,ppvID3DXPMesh>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvID3DXPMesh
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<ID3DXSPMesh>
;ID3DXSPMesh drive de : IUnknown
	STID3DXSPMesh	STRUCT
		QueryInterface               	comethod3 ?
		AddRef                       	comethod1 ?
		Release                      	comethod1 ?
		GetNumFaces                  	comethod1 ?
		GetNumVertices               	comethod1 ?
		GetFVF                       	comethod1 ?
		GetDeclaration               	comethod2 ?
		GetOptions                   	comethod1 ?
		GetDevice                    	comethod2 ?
		CloneMeshFVF                 	comethod7 ?
		CloneMesh                    	comethod7 ?
		ClonePMeshFVF                	comethod7 ?
		ClonePMesh                   	comethod7 ?
		ReduceFaces                  	comethod2 ?
		ReduceVertices               	comethod2 ?
		GetMaxFaces                  	comethod1 ?
		GetMaxVertices               	comethod1 ?
		GetVertexAttributeWeights    	comethod2 ?
		GetVertexWeights             	comethod2 ?
	STID3DXSPMesh	ENDS
 
ID3DXSPMesh MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STID3DXSPMesh PTR[edx]).>,<&Function,ppvID3DXSPMesh>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvID3DXSPMesh
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
UNUSED16	equ	<0ffffh>
UNUSED32	equ	<0ffffffffh>
 ; ID3DXMesh::Optimize options - upper byte only, lower 3 bytes used from _D3DXMESH option flags

;_D3DXMESHOPT	UNION
	D3DXMESHOPT_COMPACT	EQU 001000000h 
	D3DXMESHOPT_ATTRSORT	EQU 002000000h 
	D3DXMESHOPT_VERTEXCACHE	EQU 004000000h 
	D3DXMESHOPT_STRIPREORDER	EQU 008000000h 
	D3DXMESHOPT_IGNOREVERTS	EQU 010000000h 	 ; optimize faces only, don't touch vertices
	D3DXMESHOPT_DONOTSPLIT	EQU 020000000h 	 ; do not split vertices shared between attribute groups when attribute sorting
	D3DXMESHOPT_DEVICEINDEPENDENT	EQU 000400000h 	 ; Only affects VCache.  uses a static known good cache size for all cards
;_D3DXMESHOPT		ENDS

 ; Subset of the mesh that has the same attribute and bone combination.
 ; This subset can be rendered in a single draw call

D3DXBONECOMBINATION	STRUCT
	AttribId DWORD ?
	FaceStart DWORD ?
	FaceCount DWORD ?
	VertexStart DWORD ?
	VertexCount DWORD ?
	BoneId DWORD ?

D3DXBONECOMBINATION		ENDS

 ; The following types of patch combinations are supported:
 ; Patch type   Basis       Degree
 ; Rect         Bezier      2,3,5
 ; Rect         B-Spline    2,3,5
 ; Rect         Catmull-Rom 3
 ; Tri          Bezier      2,3,5
 ; N-Patch      N/A         3

D3DXPATCHINFO	STRUCT
	PatchType DWORD ?
	Degree DWORD ? 
	Basis DWORD ?

D3DXPATCHINFO		ENDS

INTERFACE	equ	<ID3DXPatchMesh>
;ID3DXPatchMesh drive de : IUnknown
	STID3DXPatchMesh	STRUCT
		QueryInterface               	comethod3 ?
		AddRef                       	comethod1 ?
		Release                      	comethod1 ?
		GetNumPatches                	comethod1 ?
		GetNumVertices               	comethod1 ?
		GetDeclaration               	comethod2 ?
		GetControlVerticesPerPatch   	comethod1 ?
		GetOptions                   	comethod1 ?
		GetDevice                    	comethod2 ?
		GetPatchInfo                 	comethod2 ?
		GetVertexBuffer              	comethod2 ?
		GetIndexBuffer               	comethod2 ?
		LockVertexBuffer             	comethod3 ?
		UnlockVertexBuffer           	comethod1 ?
		LockIndexBuffer              	comethod3 ?
		UnlockIndexBuffer            	comethod1 ?
		LockAttributeBuffer          	comethod3 ?
		UnlockAttributeBuffer        	comethod1 ?
		GetTessSize                  	comethod5 ?
		GenerateAdjacency            	comethod2 ?
		CloneMesh                    	comethod4 ?
		Optimize                     	comethod2 ?
		SetDisplaceParam             	comethod7 ?
		GetDisplaceParam             	comethod7 ?
		Tessellate                   	comethod3 ?
		TessellateAdaptive           	comethod5 ?
	STID3DXPatchMesh	ENDS
 
ID3DXPatchMesh MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STID3DXPatchMesh PTR[edx]).>,<&Function,ppvID3DXPatchMesh>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvID3DXPatchMesh
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<ID3DXSkinInfo>
;ID3DXSkinInfo drive de : IUnknown
	STID3DXSkinInfo	STRUCT
		QueryInterface               	comethod3 ?
		AddRef                       	comethod1 ?
		Release                      	comethod1 ?
		SetBoneInfluence             	comethod5 ?
		GetNumBoneInfluences         	comethod2 ?
		GetBoneInfluence             	comethod4 ?
		GetMaxVertexInfluences       	comethod2 ?
		GetNumBones                  	comethod1 ?
		GetMaxFaceInfluences         	comethod4 ?
		SetMinBoneInfluence          	comethod2 ?
		GetMinBoneInfluence          	comethod1 ?
		SetBoneName                  	comethod3 ?
		GetBoneName                  	comethod2 ?
		SetBoneOffsetMatrix          	comethod3 ?
		GetBoneOffsetMatrix          	comethod2 ?
		Clone                        	comethod2 ?
		Remap                        	comethod3 ?
		SetFVF                       	comethod2 ?
		SetDeclaration               	comethod2 ?
		GetFVF                       	comethod1 ?
		GetDeclaration               	comethod2 ?
		UpdateSkinnedMesh            	comethod5 ?
		ConvertToBlendedMesh         	comethod11 ?
		ConvertToIndexedBlendedMesh  	comethod12 ?
	STID3DXSkinInfo	ENDS
 
ID3DXSkinInfo MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STID3DXSkinInfo PTR[edx]).>,<&Function,ppvID3DXSkinInfo>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvID3DXSkinInfo
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
IFDEF __cplusplus
ENDIF  ;__cplusplus
;API
D3DXCreateMesh PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXCreateMeshFVF PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXCreateSPMesh PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
 ; clean a mesh up for simplification, try to make manifold
;API
D3DXCleanMesh PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXValidMesh PROTO :DWORD ,:DWORD ,:DWORD 
;API
D3DXGeneratePMesh PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXSimplifyMesh PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXComputeBoundingSphere PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXComputeBoundingBox PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXComputeNormals PROTO :DWORD ,:DWORD 
;API
D3DXCreateBuffer PROTO :DWORD ,:DWORD 
;API
D3DXLoadMeshFromXA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXLoadMeshFromXW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
D3DXLoadMeshFromX	equ	<D3DXLoadMeshFromXW>
ELSE
D3DXLoadMeshFromX	equ	<D3DXLoadMeshFromXA>
ENDIF 
;API
D3DXLoadMeshFromXInMemory PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXLoadMeshFromXResource PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXSaveMeshToXA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXSaveMeshToXW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
D3DXSaveMeshToX	equ	<D3DXSaveMeshToXW>
ELSE
D3DXSaveMeshToX	equ	<D3DXSaveMeshToXA>
ENDIF 
;API
D3DXCreatePMeshFromStream PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
 ; Creates a skin info object based on the number of vertices, number of bones, and a declaration describing the vertex layout of the target vertices
 ; The bone names and initial bone transforms are not filled in the skin info object by this method.
;API
D3DXCreateSkinInfo PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
 ; Creates a skin info object based on the number of vertices, number of bones, and a FVF describing the vertex layout of the target vertices
 ; The bone names and initial bone transforms are not filled in the skin info object by this method.
;API
D3DXCreateSkinInfoFVF PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF __cplusplus
ENDIF  ;__cplusplus
;API
D3DXLoadMeshFromXof PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
 ; This similar to D3DXLoadMeshFromXof, except also returns skinning info if present in the file
 ; If skinning info is not present, ppSkinInfo will be NULL
;API
D3DXLoadSkinMeshFromXof PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
 ; The inverse of D3DXConvertTo{Indexed}BlendedMesh() functions. It figures out the skinning info from
 ; the mesh and the bone combination table and populates a skin info object with that data. The bone
 ; names and initial bone transforms are not filled in the skin info object by this method. This works
 ; with either a non-indexed or indexed blended mesh. It examines the FVF or declarator of the mesh to
 ; determine what type it is.
;API
D3DXCreateSkinInfoFromBlendedMesh PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXTessellateNPatches PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
 ;generates implied outputdecl from input decl
 ;the decl generated from this should be used to generate the output decl for
 ;the tessellator subroutines.
;API
D3DXGenerateOutputDecl PROTO :DWORD ,:DWORD 
 ;loads patches from an XFileData
 ;since an X file can have up to 6 different patch meshes in it,
 ;returns them in an array - pNumPatches will contain the number of
 ;meshes in the actual file.
;API
D3DXLoadPatchMeshFromXof PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:PDWORD ,:DWORD 
 ;computes the size a single rect patch.
;API
D3DXRectPatchSize PROTO :DWORD ,:DWORD ,:DWORD  ;output number of vertices
 ;computes the size of a single triangle patch
;API
D3DXTriPatchSize PROTO :DWORD ,:DWORD ,:DWORD  ;output number of vertices
 ;tessellates a patch into a created mesh
 ;similar to D3D RT patch
;API
D3DXTessellateRectPatch PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXTessellateTriPatch PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
 ;creates an NPatch PatchMesh from a D3DXMESH
;API
D3DXCreateNPatchMesh PROTO :DWORD ,:DWORD 
 ;creates a patch mesh
;API
D3DXCreatePatchMesh PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
 ;returns the number of degenerates in a patch mesh -
 ;text output put in string.
;API
D3DXValidPatchMesh PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXGetFVFVertexSize PROTO :DWORD 
;API
D3DXGetDeclVertexSize PROTO :DWORD ,:DWORD 
;API
D3DXGetDeclLength PROTO :DWORD 
;API
D3DXDeclaratorFromFVF PROTO :DWORD ,:DWORD 
;API
D3DXFVFFromDeclarator PROTO :DWORD ,:DWORD 
;API
D3DXWeldVertices PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 

D3DXINTERSECTINFO	STRUCT
	FaceIndex DWORD ?  ; index of face intersected
	U REAL4 ?  ; Barycentric Hit Coordinates    
	V REAL4 ?  ; Barycentric Hit Coordinates
	Dist REAL4 ?  ; Ray-Intersection Parameter Distance

D3DXINTERSECTINFO		ENDS

;API
D3DXIntersect PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD  ; Number of entries in AllHits array
;API
D3DXIntersectSubset PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD  ; Number of entries in AllHits array
;API
D3DXSplitMesh PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXIntersectTri PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD  ; Ray-Intersection Parameter Distance
;API
D3DXSphereBoundProbe PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXBoxBoundProbe PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
 ;D3DXComputeTangent
 ;
 ;Computes the Tangent vectors for the TexStage texture coordinates
 ;and places the results in the TANGENT[TangentIndex] specified in the meshes' DECL
 ;puts the binorm in BINORM[BinormIndex] also specified in the decl.
 ;
 ;If neither the binorm or the tangnet are in the meshes declaration,
 ;the function will fail.
 ;
 ;If a tangent or Binorm field is in the Decl, but the user does not
 ;wish D3DXComputeTangent to replace them, then D3DX_DEFAULT specified
 ;in the TangentIndex or BinormIndex will cause it to ignore the specified
 ;semantic.
 ;
 ;Wrap should be specified if the texture coordinates wrap.
;API
D3DXComputeTangent PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXConvertMeshSubsetToSingleStrip PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
D3DXConvertMeshSubsetToStrips PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF __cplusplus
ENDIF  ;__cplusplus
 ;////////////////////////////////////////////////////////////////////////////
 ;
 ;  Definitions of .X file templates used by mesh load/save functions
 ;    that are not RM standard
 ;
 ;////////////////////////////////////////////////////////////////////////////
 ; {3CF169CE-FF7C-44ab-93C0-F78F62D172E2}
sDXFILEOBJ_XSkinMeshHeader	TEXTEQU	<{03cf169ceh,0ff7ch,044abh,(093h,0c0h,0f7h,08fh,062h,0d1h,072h,0e2h}}>
 ; {B8D65549-D7C9-4995-89CF-53A9A8B031E3}
sDXFILEOBJ_VertexDuplicationIndices	TEXTEQU	<{0b8d65549h,0d7c9h,04995h,(089h,0cfh,053h,0a9h,0a8h,0b0h,031h,0e3h}}>
 ; {A64C844A-E282-4756-8B80-250CDE04398C}
sDXFILEOBJ_FaceAdjacency	TEXTEQU	<{0a64c844ah,0e282h,04756h,(08bh,080h,025h,0ch,0deh,04h,039h,08ch}}>
 ; {6F0D123B-BAD2-4167-A0D0-80224F25FABB}
sDXFILEOBJ_SkinWeights	TEXTEQU	<{06f0d123bh,0bad2h,04167h,(0a0h,0d0h,080h,022h,04fh,025h,0fah,0bbh}}>
 ; {A3EB5D44-FC22-429d-9AFB-3221CB9719A6}
sDXFILEOBJ_Patch	TEXTEQU	<{0a3eb5d44h,0fc22h,0429dh,(09ah,0fbh,032h,021h,0cbh,097h,019h,0a6h}}>
 ; {D02C95CC-EDBA-4305-9B5D-1820D7704BBF}
sDXFILEOBJ_PatchMesh	TEXTEQU	<{0d02c95cch,0edbah,04305h,(09bh,05dh,018h,020h,0d7h,070h,04bh,0bfh}}>
 ; {B9EC94E1-B9A6-4251-BA18-94893F02C0EA}
sDXFILEOBJ_PatchMesh9	TEXTEQU	<{0b9ec94e1h,0b9a6h,04251h,(0bah,018h,094h,089h,03fh,02h,0c0h,0eah}}>
 ; {B6C3E656-EC8B-4b92-9B62-681659522947}
sDXFILEOBJ_PMInfo	TEXTEQU	<{0b6c3e656h,0ec8bh,04b92h,(09bh,062h,068h,016h,059h,052h,029h,047h}}>
 ; {917E0427-C61E-4a14-9C64-AFE65F9E9844}
sDXFILEOBJ_PMAttributeRange	TEXTEQU	<{0917e0427h,0c61eh,04a14h,(09ch,064h,0afh,0e6h,05fh,09eh,098h,044h}}>
 ; {574CCC14-F0B3-4333-822D-93E8A8A08E4C}
sDXFILEOBJ_PMVSplitRecord	TEXTEQU	<{0574ccc14h,0f0b3h,04333h,(082h,02dh,093h,0e8h,0a8h,0a0h,08eh,04ch}}>
 ; {B6E70A0E-8EF9-4e83-94AD-ECC8B0C04897}
sDXFILEOBJ_FVFData	TEXTEQU	<{0b6e70a0eh,08ef9h,04e83h,(094h,0adh,0ech,0c8h,0b0h,0c0h,048h,097h}}>
 ; {F752461C-1E23-48f6-B9F8-8350850F336F}
sDXFILEOBJ_VertexElement	TEXTEQU	<{0f752461ch,01e23h,048f6h,(0b9h,0f8h,083h,050h,085h,0fh,033h,06fh}}>
 ; {BF22E553-292C-4781-9FEA-62BD554BDD93}
sDXFILEOBJ_DeclData	TEXTEQU	<{0bf22e553h,0292ch,04781h,(09fh,0eah,062h,0bdh,055h,04bh,0ddh,093h}}>
 ; {F1CFE2B3-0DE3-4e28-AFA1-155A750A282D}
sDXFILEOBJ_EffectFloats	TEXTEQU	<{0f1cfe2b3h,0de3h,04e28h,(0afh,0a1h,015h,05ah,075h,0ah,028h,02dh}}>
 ; {D55B097E-BDB6-4c52-B03D-6051C89D0E42}
sDXFILEOBJ_EffectString	TEXTEQU	<{0d55b097eh,0bdb6h,04c52h,(0b0h,03dh,060h,051h,0c8h,09dh,0eh,042h}}>
 ; {622C0ED0-956E-4da9-908A-2AF94F3CE716}
sDXFILEOBJ_EffectDWord	TEXTEQU	<{0622c0ed0h,0956eh,04da9h,(090h,08ah,02ah,0f9h,04fh,03ch,0e7h,016h}}>
 ; {3014B9A0-62F5-478c-9B86-E4AC9F4E418B}
sDXFILEOBJ_EffectParamFloats	TEXTEQU	<{03014b9a0h,062f5h,0478ch,(09bh,086h,0e4h,0ach,09fh,04eh,041h,08bh}}>
 ; {1DBC4C88-94C1-46ee-9076-2C28818C9481}
sDXFILEOBJ_EffectParamString	TEXTEQU	<{01dbc4c88h,094c1h,046eeh,(090h,076h,02ch,028h,081h,08ch,094h,081h}}>
 ; {E13963BC-AE51-4c5d-B00F-CFA3A9D97CE5}
sDXFILEOBJ_EffectParamDWord	TEXTEQU	<{0e13963bch,0ae51h,04c5dh,(0b0h,0fh,0cfh,0a3h,0a9h,0d9h,07ch,0e5h}}>
 ; {E331F7E4-0559-4cc2-8E99-1CEC1657928F}
sDXFILEOBJ_EffectInstance	TEXTEQU	<{0e331f7e4h,0559h,04cc2h,(08eh,099h,01ch,0ech,016h,057h,092h,08fh}}>
 ; {9E415A43-7BA6-4a73-8743-B73D47E88476}
sDXFILEOBJ_AnimTicksPerSecond	TEXTEQU	<{09e415a43h,07ba6h,04a73h,(087h,043h,0b7h,03dh,047h,0e8h,084h,076h}}>
ENDIF  ;__D3DX9MESH_H__
