 ;
;*  Copyright (C) 1998-1999 Microsoft Corporation.  All Rights Reserved.
;*  File:       dxfile.h
;*  Content:    DirectX File public header file
;***************************************************************************/
IFNDEF __DXFILE_H__
IFDEF __cplusplus
ENDIF 
DXFILEFORMAT_BINARY	equ	<0>
DXFILEFORMAT_TEXT	equ	<1>
DXFILEFORMAT_COMPRESSED	equ	<2>
DXFILELOAD_FROMFILE	equ	<000h>
DXFILELOAD_FROMRESOURCE	equ	<001h>
DXFILELOAD_FROMMEMORY	equ	<002h>
DXFILELOAD_FROMSTREAM	equ	<004h>
DXFILELOAD_FROMURL	equ	<008h>

DXFILELOADRESOURCE	STRUCT
	hModule DWORD ?
	lpName DWORD ?
	lpType DWORD ?

DXFILELOADRESOURCE		ENDS


DXFILELOADMEMORY	STRUCT
	lpMemory DWORD ?
	dSize DWORD ?

DXFILELOADMEMORY		ENDS

 ;
;* DirectX File object types.
;*/
IFNDEF WIN_TYPES
ENDIF 
 ;
;* API for creating IDirectXFile interface.
;*/
;API
DirectXFileCreate PROTO :DWORD 
 ;
;* The methods for IUnknown
;*/
 ;
;* The methods for IDirectXFileObject
;*/
 ;
;* DirectX File interfaces.
;*/
INTERFACE	equ	<IDirectXFile>
;IDirectXFile drive de : IUnknown
	STIDirectXFile	STRUCT
		PURE                         	comethod1 ?
		CreateSaveObject             	comethod4 ?
		RegisterTemplates            	comethod3 ?
	STIDirectXFile	ENDS
 
IDirectXFile MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STIDirectXFile PTR[edx]).>,<&Function,ppvIDirectXFile>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvIDirectXFile
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<IDirectXFileEnumObject>
;IDirectXFileEnumObject drive de : IUnknown
	STIDirectXFileEnumObject	STRUCT
		PURE                         	comethod1 ?
		GetDataObjectById            	comethod3 ?
		GetDataObjectByName          	comethod3 ?
	STIDirectXFileEnumObject	ENDS
 
IDirectXFileEnumObject MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STIDirectXFileEnumObject PTR[edx]).>,<&Function,ppvIDirectXFileEnumObject>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvIDirectXFileEnumObject
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<IDirectXFileSaveObject>
;IDirectXFileSaveObject drive de : IUnknown
	STIDirectXFileSaveObject	STRUCT
		PURE                         	comethod1 ?
		CreateDataObject             	comethod7 ?
		SaveData                     	comethod2 ?
	STIDirectXFileSaveObject	ENDS
 
IDirectXFileSaveObject MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STIDirectXFileSaveObject PTR[edx]).>,<&Function,ppvIDirectXFileSaveObject>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvIDirectXFileSaveObject
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<IDirectXFileObject>
;IDirectXFileObject drive de : IUnknown
	STIDirectXFileObject	STRUCT
		PURE                         	comethod1 ?
	STIDirectXFileObject	ENDS
 
IDirectXFileObject MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STIDirectXFileObject PTR[edx]).>,<&Function,ppvIDirectXFileObject>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvIDirectXFileObject
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<IDirectXFileData>
;IDirectXFileData drive de : IDirectXFileObject
	STIDirectXFileData	STRUCT
		PURE                         	comethod1 ?
		GetData                      	comethod4 ?
		GetType                      	comethod2 ?
		GetNextObject                	comethod2 ?
		AddDataObject                	comethod2 ?
		AddDataReference             	comethod3 ?
		AddBinaryObject              	comethod6 ?
	STIDirectXFileData	ENDS
 
IDirectXFileData MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STIDirectXFileData PTR[edx]).>,<&Function,ppvIDirectXFileData>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvIDirectXFileData
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<IDirectXFileDataReference>
;IDirectXFileDataReference drive de : IDirectXFileObject
	STIDirectXFileDataReference	STRUCT
		PURE                         	comethod1 ?
		Resolve                      	comethod2 ?
	STIDirectXFileDataReference	ENDS
 
IDirectXFileDataReference MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STIDirectXFileDataReference PTR[edx]).>,<&Function,ppvIDirectXFileDataReference>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvIDirectXFileDataReference
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
INTERFACE	equ	<IDirectXFileBinary>
;IDirectXFileBinary drive de : IDirectXFileObject
	STIDirectXFileBinary	STRUCT
		PURE                         	comethod1 ?
		GetSize                      	comethod2 ?
		GetMimeType                  	comethod2 ?
		Read                         	comethod4 ?
	STIDirectXFileBinary	ENDS
 
IDirectXFileBinary MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STIDirectXFileBinary PTR[edx]).>,<&Function,ppvIDirectXFileBinary>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvIDirectXFileBinary
    mov edx, [edx]
    InvokeInterface
ENDM		
 
 
 ;
;* DirectXFile Object Class Id (for CoCreateInstance())
;*/
sCLSID_CDirectXFile	TEXTEQU	<{04516ec43h,08f20h,011d0h,(09bh,06dh,000h,000h,0c0h,078h,01bh,0c3h}}>
 ;
;* DirectX File Interface GUIDs.
;*/
sIID_IDirectXFile	TEXTEQU	<{03d82ab40h,062dah,011cfh,(0abh,039h,00h,020h,0afh,071h,0e4h,033h}}>
sIID_IDirectXFileEnumObject	TEXTEQU	<{03d82ab41h,062dah,011cfh,(0abh,039h,00h,020h,0afh,071h,0e4h,033h}}>
sIID_IDirectXFileSaveObject	TEXTEQU	<{03d82ab42h,062dah,011cfh,(0abh,039h,00h,020h,0afh,071h,0e4h,033h}}>
sIID_IDirectXFileObject	TEXTEQU	<{03d82ab43h,062dah,011cfh,(0abh,039h,00h,020h,0afh,071h,0e4h,033h}}>
sIID_IDirectXFileData	TEXTEQU	<{03d82ab44h,062dah,011cfh,(0abh,039h,00h,020h,0afh,071h,0e4h,033h}}>
sIID_IDirectXFileDataReference	TEXTEQU	<{03d82ab45h,062dah,011cfh,(0abh,039h,00h,020h,0afh,071h,0e4h,033h}}>
sIID_IDirectXFileBinary	TEXTEQU	<{03d82ab46h,062dah,011cfh,(0abh,039h,00h,020h,0afh,071h,0e4h,033h}}>
 ;
;* DirectX File Header template's GUID.
;*/
sTID_DXFILEHeader	TEXTEQU	<{03d82ab43h,062dah,011cfh,(0abh,039h,00h,020h,0afh,071h,0e4h,033h}}>
 ;
;* DirectX File errors.
;*/
_FACDD	equ	<0876h>
DXFILE_OK	equ	<0>
IFDEF __cplusplus
ENDIF 
ENDIF  ; _DXFILE_H_ 
